#uses "fwSystemOverview/fwSystemOverview.ctl"
#uses "fwSystemOverview/fwSystemOverviewFsm.ctl"
#uses "fwSystemOverview/fwSystemOverviewReport.ctl"
#uses "fwSystemOverview/fwSystemOverviewNotifications.ctl"
#uses "fwSystemOverview/fwSystemOverviewAlarmsMasking.ctl" //needed for the alarm statistics

// For overviews
#uses "fwInstallationDB.ctl"

const string FWSYSOVERVIEWLONGTERMREPORT_REPORTS_FOLDER = "reportsLong";
const string FWSYSOVERVIEWLONGTERMREPORT_REPORT_DPTYPE = "_FwSystemOverviewReportUrl";
const string FWSYSOVERVIEWLONGTERMREPORT_REPORT_PREFIX = "reportUrls_";

bool plotOnTheSameChart = false;
const int NUMBER_OF_ELEMETS_IN = 9;
string connectionName = "reportsConnection";
const string gWebPath = "/user/unicryo/www/MOON/HtmlFiles/";

///////////////////////////////////////////Alarm Statistics//////////////////////////////////
const int interval = 7; //last 30 days

//beginning executable code:
void fwSysOverviewLongTermReport_generateAlarmStatistics()
{
DebugTN("WebGen: fwSysOverviewLongTermReport_generateOverallStatistics()");
  fwSysOverviewLongTermReport_generateOverallStatistics();
DebugTN("WebGen: fwSysOverviewLongTermReport_generateOverAllStatisticsMainPage()");
  fwSysOverviewLongTermReport_generateOverAllStatisticsMainPage();
DebugTN("WebGen: fwSysOverviewLongTermReport_alarmsMainPage()");
  fwSysOverviewLongTermReport_alarmsMainPage();
DebugTN("WebGen: fwSysOverviewLongTermReport_generateTreesMainPages()");
  fwSysOverviewLongTermReport_generateTreesMainPages();
DebugTN("WebGen: fwSysOverviewLongTermReport_generateAlarmOverviewHistogram()");
  fwSysOverviewLongTermRport_generateAlarmOverviewHistogram();   
DebugTN("WebGen: fwSysOverviewLongTermReport_generateTreeAlarmHistogram()");
  fwSysOverviewLongTermReport_generateTreeAlarmHistogram();
DebugTN("WebGen: fwSysOverviewLongTermReport_generateTreeAlarmHistogramPerType()");
  fwSysOverviewLognTermReport_generateTreeAlarmHistogramPerType();
DebugTN("WebGen: fwSysOverviewLongTermReport_getTreeSMSHistogram()");
  fwSysOverviewLongTermReport_getTreeSMSHistogram();
DebugTN("WebGen: fwSysOverviewLongTermReport_generateAlarmPerApplicationChartPie()");
  fwSysOverview_generateAlarmPerApplicationChartPie();
DebugTN("WebGen: fwSysOverviewLongTermReport_generateListMostRecurrentAlarms()");
  fwSysOverviewLongTermReport_generateListMostRecurrentAlarms();
DebugTN("WebGen: fwSysOverviewLongTermReport_generateListLongestLivingAlarms()");
  fwSysOverviewLongTermReport_generateListLongestLivingAlarms();


  return;
}

void fwSysOverviewLongTermReport_generateOverallHigestAlarmRates()
{    
  dyn_dyn_mixed data;
  dyn_dyn_mixed dpeData;
  dyn_dyn_mixed allData;
  string timesPerDay = 20;
  
  allData[1][1] = "Date";
  for(int i = 1; i <= interval; i++)  
  {
    time t = getCurrentTime() - (interval-i)*3600*24;
    string str;
    sprintf(str, "%04d-%02d-%02d", year(t), month(t),day(t));
    allData[i+1][1] = str;
  }
  
  fwSysOverviewLongTermReport_getHighestAlarmRates(interval, data, timesPerDay);
//DebugN("data", data);
  //build data matrix:
  for(int i = 1; i <= dynlen(data); i++)
  {
    dyn_dyn_mixed dpeData;
    //array initialization
    dynClear(dpeData);
    for(int z= 1; z <= dynlen(allData); z++)
    {
      dpeData[z][1] = allData[z][1];      
      dpeData[z][2] = 0;      
    }
    string dpe = data[i][1];

    for(int j = i; j <= dynlen(data); j++)
    {
      if(data[j][1] != dpe)
      {
        i = j;
        break;
      }
      
      //dealing with the same dp. Find the right date:
      for(int k = 1; k <= dynlen(allData); k++)
      {
        if(allData[k][1] == data[j][2])
        {
          //found the right dp and the right date:
          i = j;
          dpeData[k][1] = data[j][2];
          dpeData[k][2] = data[j][3];
          break;
        }
      }
    }//end of loop over j
//DebugN("dpeData", dpeData);    
    
    if(dynlen(dpeData))
    {
//      DebugN("appending to histogram: ", dpeData);
      _fwGoogleApi_addColumnToHistogramData(dpe, dpeData, allData);
      dynClear(dpeData);
      
    }
  }//end of loop over i


  
  string title = "Alarms raised at least " + timesPerDay + " times per day";
  string xAxis = "Date";
  string dir = gWebPath + "statistics";
  if(access(dir, W_OK))
    mkdir(dir, "777");

  file f = fopen(dir + "/highestAlarmRates.html", "w");
    
  fputs(fwGoogleApi_columnChart(title, xAxis, allData), f);
  fclose(f);
  
  return;
}

int fwSysOverviewLongTermReport_getHighestAlarmRates(const int interval, dyn_dyn_mixed &data, const int timesPerDay = 20)
{    
  dyn_mixed record;
  time startDate = getCurrentTime() - (interval*3600*24);
  string date;
  sprintf(date, "%04d-%02d-%02d", year(startDate), month(startDate), day(startDate));
  string sys = getSystemName();
  strreplace(sys, ":", "");
  string query = "select * from (select e.comment_, dt, count(ah.element_id) cnt from (select element_id, to_char(ts, 'YYYY-MM-DD') dt " +
                 "from alerthistory where direction = 1 and ts > to_date(\'"+date+"\', 'YYYY-MM-DD')and sys_id = (select sys_id from systems " +
                 "where sys_name = \'"+sys+"\')) ah, elements e where e.element_id = ah.element_id group by ah.dt, e.comment_ order by e.comment_, ah.dt " +
                 ")where cnt > " + timesPerDay;
  _fwSysOverviewLongTermReport_executeQuery(query, record, data);

  return 0;
}


void fwSysOverviewLongTermReport_generateOverallHigestArchivingRates()
{    
  dyn_dyn_mixed data;
  dyn_dyn_mixed dpeData;
  dyn_dyn_mixed allData;
  int timesPerDay = 1440;
  
  allData[1][1] = "Date";
  for(int i = 1; i <= interval; i++)  
  {
    time t = getCurrentTime() - (interval-i)*3600*24;
    string str;
    sprintf(str, "%04d-%02d-%02d", year(t), month(t),day(t));
    allData[i+1][1] = str;
  }
  
  fwSysOverviewLongTermReport_getHighestArchivingRates(interval, data);
//DebugN("data", data);
  //build data matrix:
  for(int i = 1; i <= dynlen(data); i++)
  {
    dyn_dyn_mixed dpeData;
    //array initialization
    dynClear(dpeData);
    for(int z= 1; z <= dynlen(allData); z++)
    {
      dpeData[z][1] = allData[z][1];      
      dpeData[z][2] = 0;      
    }
    string dpe = data[i][1];

    for(int j = i; j <= dynlen(data); j++)
    {
      if(data[j][1] != dpe)
      {
        i = j;
        break;
      }
      
      //dealing with the same dp. Find the right date:
      for(int k = 1; k <= dynlen(allData); k++)
      {
        if(allData[k][1] == data[j][2])
        {
          //found the right dp and the right date:
          i = j;
          dpeData[k][1] = data[j][2];
          dpeData[k][2] = data[j][3];
          break;
        }
      }
    }//end of loop over j
//DebugN("dpeData", dpeData);    
    
    if(dynlen(dpeData))
    {
//      DebugN("appending to histogram: ", dpeData);
      _fwGoogleApi_addColumnToHistogramData(dpe, dpeData, allData);
      dynClear(dpeData);
      
    }
  }//end of loop over i


  
  string title = "Dpes archived at higher frequency that once every " + (timesPerDay/60/24) + " minute(s)";
  string xAxis = "Date";
  string dir = gWebPath + "statistics";
  if(access(dir, W_OK))
    mkdir(dir, "777");

  file f = fopen(dir + "/highestArchivingRates.html", "w");
    
  fputs(fwGoogleApi_columnChart(title, xAxis, allData), f);
  fclose(f);
  
  return;
}

int fwSysOverviewLongTermReport_getHighestArchivingRates(const int interval, dyn_dyn_mixed &data, const int timesPerDay = 1440)
{    
  dyn_mixed record;
  time startDate = getCurrentTime() - (interval*3600*24);
  string date;
  sprintf(date, "%04d-%02d-%02d", year(startDate), month(startDate), day(startDate));
  string sys = getSystemName();
  strreplace(sys, ":", "");
  string query = "select * from (select e.element_name, dt, count(ev.element_id) cnt from (select element_id, to_char(ts, 'YYYY-MM-DD') dt from eventhistory where ts > to_date(\'"+date+"\', \'YYYY-MM-DD\') " +
			              "and sys_id = (select sys_id from systems where sys_name = \'"+sys+"\')) ev, elements e where e.element_id = ev.element_id group by ev.dt, e.element_name order by e.element_name, ev.dt) where cnt > " + timesPerDay;
     
  _fwSysOverviewLongTermReport_executeQuery(query, record, data);

  return 0;
}


void fwSysOverviewLongTermReport_generateOverAllStatisticsMainPage(const int x = 1000, const int y = 500)
{
  string date = getCurrentTime();
  date = substr(date, 0, strlen(date)-7);
  string html = "<title>MOON Overall Statistics</title>\n";
         html += "<h1 style=\"font:18px Verdana, Arial, Helvetica, sans-serif\" align=\"left\">MOON Overall Statistics</h1>\n";
         html += "<p align=\"right\" style=\"font:12px Verdana, Arial, Helvetica, sans-serif\"><strong>Content generated on "+date+"</strong></p>\n";
         html += "<p style=\"font:12px Verdana, Arial, Helvetica, sans-serif\">This page shows the overall archiving rates of MOON for values and alarms. The following histograms are available:</p>\n";
         html += "<ul>\n";
         html += "<li style=\"font:12px Verdana, Arial, Helvetica, sans-serif\">Time distribution of archived values</li>\n";
         html += "<li style=\"font:12px Verdana, Arial, Helvetica, sans-serif\">Dpes with highest archiving rate</li>\n";
         html += "<li style=\"font:12px Verdana, Arial, Helvetica, sans-serif\">Time distribution of archived alarms</li>\n";
         html += "<li style=\"font:12px Verdana, Arial, Helvetica, sans-serif\">List of most recurrent alarms</li>\n";
//         html += "<li style=\"font:12px Verdana, Arial, Helvetica, sans-serif\">Flickering Alarms</li>\n";
         html += "</ul>\n";         
         
         html += "<div>\n";
         html += "  <iframe height=\""+y+"\" width=\""+x+"\" scrolling=\"no\" frameborder=\"0\" src=\"values.html\"></iframe>\n";
         html += "</div>\n";
         
         html += "<div>\n";
         html += "  <iframe height=\""+y+"\" width=\""+x+"\" scrolling=\"no\" frameborder=\"0\" src=\"highestArchivingRates.html\"></iframe>\n";
         html += "</div>\n";
         
         html += "<div>\n";
         html += "  <iframe height=\""+y+"\" width=\""+x+"\" scrolling=\"no\" frameborder=\"0\" src=\"alarms.html\"></iframe>\n";
         html += "</div>\n";

         html += "<div>\n";
         html += "  <iframe height=\""+y+"\" width=\""+x+"\" scrolling=\"no\" frameborder=\"0\" src=\"highestAlarmRates.html\"></iframe>\n";
         html += "</div>\n";
         
         
//         html += "<div>\n";
//         html += "  <iframe height=\""+y+"\" width=\""+x+"\" scrolling=\"no\" frameborder=\"0\" src=\"flickeringAlarms.html\"></iframe>\n";
//         html += "</div>\n";
 
  string dir = gWebPath + "statistics";       
  if(access(dir, W_OK))
    mkdir(dir, "777");
  
  file f = fopen(dir + "/overallStatistics.html", "w+");
  fputs(html, f);
  fclose(f); 
  
  return;
}


void fwSysOverviewLongTermReport_generateOverallStatistics()
{
  fwSysOverviewLongTermRport_generateArchvingHistogram("values");
  fwSysOverviewLongTermRport_generateArchvingHistogram("alarms");
//  fwSysOverviewLongTermReport_generateFlickeringAlarms();
  fwSysOverviewLongTermReport_generateOverallHigestAlarmRates();
  fwSysOverviewLongTermReport_generateOverallHigestArchivingRates();
  
  return;
}

/*
void fwSysOverviewLongTermReport_generateFlickeringAlarms(const int interval = 30)
{    
  dyn_int types;
  dyn_dyn_mixed allData;
  dyn_dyn_mixed data;
  
  allData[1][1] = "Date";
  for(int i = 1; i <= interval; i++)  
  {
    time t = getCurrentTime() - (interval-i)*3600*24;
    string str;
    sprintf(str, "%04d-%02d-%02d", year(t), month(t),day(t));
    allData[i+1][1] = str;
  }
  
  dynClear(data);
  fwSysOverviewLongTermReport_getFlickeringAlarms(interval, data);

  for(int i = 1; i <= dynlen(data); i++)
  {
    dyn_dyn_mixed dpeData;
    //array initialization
    for(int z= 1; z <= dynlen(allData); z++)
    {
      dpeData[z][1] = allData[z][1];      
      dpeData[z][2] = 0;      
    }
    
    dpeData[dynlen(allData)] = 0;
    
    
    string dpe = data[i][1];
    for(int j = i; j <= dynlen(data); j++)
    {
      if(data[j][1] != dpe)
      {
        i = j;
        break;
      }
      
      //dealing with the same dp. Find the right date:
      for(int k = 1; k <= dynlen(allData); k++)
      {
        if(allData[k][1] == data[j][2])
        {
          //found the right dp and the right date:
          i = j;
          dpeData[k][1] = data[j][2];
          dpeData[k][2] = data[j][3];
          break;
        }
      }
    }//end of loop over j
    if(dynlen(dpeData))
    {
//      DebugN("appending to histogram: ", dpeData);
      _fwGoogleApi_addColumnToHistogramData(dpe, dpeData, allData);
    }
  }//end of loop over i

//DebugN(allData);
  
  string title = "Time distribution of flickering alarms";
  string xAxis = "Date";
  string yAxis = "Number of Alarms triggered per day";
  string dir = "/user/unicryo/www/MOON/statistics";
  if(access(dir, W_OK))
    mkdir(dir, "777");
  
//  DebugN("Generating file: " + dir + "/overallAlarmStatistics.html");
  file f = fopen(dir + "/flickeringAlarms.html", "w");
//  fputs(fwGoogleApi_comboChart(title, xAxis, yAxis, allData), f);
  fputs(fwGoogleApi_columnChart(title, xAxis, allData), f);
  fclose(f);
 
 return;
}

void fwSysOverviewLongTermReport_getFlickeringAlarms(const int interval, dyn_dyn_mixed &data, int count = 20)
{
  dyn_mixed record;
  time startDate = getCurrentTime() - (interval*3600*24);
  string date;
  sprintf(date, "%04d-%02d-%02d", year(startDate), month(startDate), day(startDate));
  string sys = getSystemName();
  strreplace(sys, ":", "");
  string query;

  time t0 = getCurrentTime();
  
  query = "select * from ( "+
            "select e.comment_, dt, count(ah.element_id) cnt from "+
              "(select element_id, to_char(ts, 'YYYY-MM-DD') dt from alerthistory where direction =1 and ts > to_date(\'"+date+"\', 'YYYY-MM-DD') and sys_id = (select sys_id from systems where sys_name = \'"+sys+"\') and direction = 1 " + 
             ") ah, elements e "+
            "where e.element_id = ah.element_id group by ah.dt, e.comment_ order by e.comment_, ah.dt, cnt desc) "+
            "where cnt > " + count;
  
  _fwSysOverviewLongTermReport_executeQuery(query, record, data);
  time t1 = getCurrentTime();
  int elapsed = t1-t0;
  
  //DebugN("Elapsed: " + elapsed + ", Query: " + query + ", data: ", data);  
}  
*/

void fwSysOverviewLongTermRport_generateArchvingHistogram(string type)
{    
  dyn_int types;
  dyn_string applications;
  fwSystemOverviewFsm_getTrees(applications);
  dyn_dyn_mixed allData;
  dyn_dyn_mixed data;
  
  allData[1][1] = "Date";
  for(int i = 1; i <= interval; i++)  
  {
    time t = getCurrentTime() - (interval-i)*3600*24;
    string str;
    sprintf(str, "%04d-%02d-%02d", year(t), month(t),day(t));
    allData[i+1][1] = str;
  }
  
  dynClear(data);
  fwSysOverviewLongTermReport_getArchivingHistogram(type, interval, data);
    
  if(dynlen(data))
    _fwGoogleApi_addColumnToHistogramData(strtoupper(type), data, allData);
  
  string title = "Archiving rates per date";
  string xAxis = "Date";
  string yAxis = "Number of Alarms triggered";
  string dir = gWebPath + "statistics";
  if(access(dir, W_OK))
    mkdir(dir, "777");
  
//  DebugN("Generating file: " + dir + "/overallAlarmStatistics.html");
  file f = fopen(dir + "/"+type+".html", "w");
  fputs(fwGoogleApi_lineChart(title, allData), f);
  fclose(f);
 
 return;
}

int fwSysOverviewLongTermReport_getArchivingHistogram(string type, const int interval, dyn_dyn_mixed &allData)
{    
  dyn_mixed record;
  time startDate = getCurrentTime() - (interval*3600*24);
  string date;
  sprintf(date, "%04d-%02d-%02d", year(startDate), month(startDate), day(startDate));
  string sys = getSystemName();
  strreplace(sys, ":", "");
  string query;
  dyn_dyn_mixed data;
  
  time t0 = getCurrentTime();
  string table;
  if(strtolower(type) == "values")
  {
    query = "select 'EVENTHISTORY_' || substr(tablespace_name, 12)  from arc_archive where status != 'OFFLINE' and group_name = 'EVENT' and tablespace_name like ('MOON_EVENT%')";  
  }
  else if(strtolower(type) == "alarms")
  {
    query = "select 'ALERTHISTORY_' || substr(tablespace_name, 12)  from arc_archive where status != 'OFFLINE' and group_name = 'ALERT' and tablespace_name like ('MOON_ALERT%')";  
  }
  
  _fwSysOverviewLongTermReport_executeQuery(query, record, data);
  dyn_dyn_mixed localData;
DebugN("Finding out total number of archived values. Type: " + type);  
DebugN("Found "+dynlen(data)+" tables ONLINE");  

  for(int i = 1; i<= dynlen(data); i++)
  {
    table = data[i][1];
  
    query = "select dt, count(*) from ( " +
              "select to_char(ts, 'YYYY-MM-DD') dt " +
              "from " + table + " " +
              "where ts > to_date(\'"+date+"\', 'YYYY-MM-DD') and sys_id = (select sys_id from systems where sys_name = \'"+sys+"\') " +
            ")group by dt"; 

DebugTN("Querying data from table: " + table);

    _fwSysOverviewLongTermReport_executeQuery(query, record, localData);
    
DebugTN("End of Querying data from table: " + table);

    if (dynlen(localData) > 0)
      dynAppend(allData, localData);
    dynClear(localData);
  }
//  DebugN("Elapsed: " + (getCurrentTime() - t0) + ", Query: " + query);  

  return 0;
}

void fwSysOverviewLongTermReport_generateListLongestLivingAlarms()
{
  dyn_dyn_mixed data;
  dyn_string trees;
  fwSystemOverviewFsm_getTrees(trees);
  string label;  
  
  for(int i = 1; i <= dynlen(trees); i++)
  {
    fwUi_getLabel(trees[i], trees[i], label);
    dynClear(data);
    fwSysOverviewLongTermReport_getLongestLivingAlarms(label, interval, data);
    dyn_string headers = makeDynString("Alarm", "Occurrences"); 
    string dir = gWebPath + strtolower(label) + "/alarms";
    if(access(dir, W_OK))
      mkdir(dir, "777");

    
    file f = fopen(dir + "/longestLivingAlarms.html", "w");
    
    fputs(fwGoogleApi_table(headers, data), f);
    fclose(f);
  }
  
 return;
}

int fwSysOverviewLongTermReport_getLongestLivingAlarms(string tree, const int interval, dyn_dyn_mixed &data, int n = 10)
{    
  dyn_mixed record;
  time startDate = getCurrentTime() - (interval*3600*24);
  string date;
  sprintf(date, "%04d-%02d-%02d", year(startDate), month(startDate), day(startDate));
  string sys = getSystemName();
  strreplace(sys, ":", "");
  string query = "select alarm, to_number(to_char(to_date(\'1\', 'J')+diff, 'J')-1) || \'d \' || to_char(to_date(\'00\', \'HH24\')+ diff, \'HH24\') || \'h \' || to_char(to_date(\'00\', \'MI\')+ diff, \'MI\') || \'min \' || to_char(to_date(\'00\', \'SS\')+ diff, \'SS\') || \'s \' from ( "+
	                  "select e.comment_ || ':' || ls.getls_at(ah.text,1) alarm, ah.partner-ah.ts diff "+
	                  "from alerthistory ah, elements e "+
	                  "where e.element_id = ah.element_id and e.element_id in (select element_id from elements where sys_id = (select sys_id from systems where sys_name = \'"+sys+"\')) and e.element_id in (select element_id from elements where comment_ like \'%("+tree+")%\') and direction = 1 and ts>to_date(\'"+date+"\',\'YYYY-MM-DD\') "+
	                  "order by diff desc "+
	                ") "+
                  "where rownum <= "+n;
     
  _fwSysOverviewLongTermReport_executeQuery(query, record, data);

  return 0;
}

void fwSysOverviewLongTermReport_generateListMostRecurrentAlarms()
{    
  dyn_dyn_mixed data;
  dyn_string trees;
  fwSystemOverviewFsm_getTrees(trees);
  string label;  
  
  for(int i = 1; i <= dynlen(trees); i++)
  {
    fwUi_getLabel(trees[i], trees[i], label);
    dynClear(data);
    fwSysOverviewLongTermReport_getMostRecurrentAlarms(label, interval, data);
    string title = "Most recurrent Alarms";
    dyn_string headers = makeDynString("Alarm", "Occurrences"); 
    string dir = gWebPath + strtolower(label) + "/alarms";
    if(access(dir, W_OK))
      mkdir(dir, "777");

    file f = fopen(dir + "/recurrentAlarms.html", "w");
    
    fputs(fwGoogleApi_table(headers, data), f);
    fclose(f);
  }
  
 return;
}

int fwSysOverviewLongTermReport_getMostRecurrentAlarms(string tree, const int interval, dyn_dyn_mixed &data)
{    
  dyn_mixed record;
  time startDate = getCurrentTime() - (interval*3600*24);
  string date;
  sprintf(date, "%04d-%02d-%02d", year(startDate), month(startDate), day(startDate));
  string sys = getSystemName();
  strreplace(sys, ":", "");
  string query = "select alarm, count(*) occurrences from ( " +
	               "   select e.comment_ || ':' || ls.getls_at(ah.text,1) alarm " +
	               "   from alerthistory ah, elements e " +
	               "   where e.element_id = ah.element_id and e.element_id in (select element_id from elements where sys_id = (select sys_id from systems where sys_name = \'"+sys+"\')) and e.element_id in (select element_id from elements where comment_ like \'%("+tree+")%\') and direction = 1 and ts>to_date(\'"+date+"\', \'YYYY-MM-DD\')) " +
                 "group by  alarm order by occurrences desc";
     
  _fwSysOverviewLongTermReport_executeQuery(query, record, data);
//DebugN(query, data);  

  return 0;
}

void fwSysOverview_generateAlarmPerApplicationChartPie()
{  
  dyn_dyn_mixed data;
  dyn_dyn_mixed allData;
  dyn_string trees;
  fwSystemOverviewFsm_getTrees(trees);

  for(int i = 1; i <= dynlen(trees); i++)
  {  
    dynClear(data);
    allData[1][1] = "Applications";
    allData[1][2] = "\'Alarms\'";
    
    fwUi_getLabel(trees[i], trees[i], trees[i]);
    fwSysOverviewLongTermReport_getTreeAlarmDistributionPerApplication(trees[i], interval, data);
  
    string title = "MOON Alarm distribution per "+trees[i]+" application";
    string dir = gWebPath + strtolower(trees[i]) + "/alarms";
    if(access(dir, W_OK))
      mkdir(dir, "777");

    file f = fopen(dir + "/applicationAlarmDistribution.html", "w");

    if (dynlen(data) > 0)
      dynAppend(allData, data);

    fputs(fwGoogleApi_pieChart(title, allData), f);
    fclose(f);
  } 
  return;
}


int fwSysOverviewLongTermReport_getTreeAlarmDistributionPerApplication(string tree, const int interval, dyn_dyn_mixed &data)
{    
  dyn_mixed record;
  time startDate = getCurrentTime() - (interval*3600*24);
  string date;
  sprintf(date, "%04d-%02d-%02d", year(startDate), month(startDate), day(startDate));
  string sys = getSystemName();
  strreplace(sys, ":", "");
  int pos = strlen(tree) + 5;
  string query="select app, count(*) from " +
               "  (select substr(e.comment_, "+pos+", 3) app " +
               "   from alerthistory ah, elements e " +
               "   where ah.element_id = e.element_id " +
               "     and e.element_id in (select element_id from elements where comment_ like (\'("+tree+")%\') and sys_id = (select sys_id from systems where sys_name = \'"+sys+"\') " +
               "      and ts > to_date(\'"+date+"\', 'YYYY-MM-DD'))) group by app ";
  _fwSysOverviewLongTermReport_executeQuery(query, record, data);

  return 0;
}


void fwSysOverviewLongTermReport_getTreeSMSHistogram()
{      
  dyn_dyn_mixed data;
//  string addressPattern = "en-dep-ice-piquet@cern.ch";
  string addressPattern = "fernando.varela.rodriguez@cern.ch";
  dyn_int types;
  dyn_dyn_mixed allData;
  dyn_string trees;
  
  fwSystemOverviewFsm_getTrees(trees);
  for(int z = 1; z <= dynlen(trees);z++)
  {
    dynClear(allData);  
    dyn_string applications = fwCU_getChildren(types, trees[z]);
    allData[1][1] = "Date";
    for(int i = 1; i <= interval; i++)  
    {
      time t = getCurrentTime() - (interval-i)*3600*24;
      string str;
      sprintf(str, "%04d-%02d-%02d", year(t), month(t),day(t));
      allData[i+1][1] = str;
    }
  
    for(int i = 1; i <= dynlen(applications); i++)
    {
      dynClear(data);
      fwSysOverviewLongTermReport_getSmsHistogram(interval, addressPattern, "("+applications[i]+")", data);
//DebugN("SMS, interval, addressPattern, applications[i], data", interval, addressPattern, applications[i], data);      
      if(dynlen(data))//add application to histogram only if there were SMSs.
        _fwGoogleApi_addColumnToHistogramData(applications[i], data, allData);
    }  
  
    string title = "SMS time distribution per application";
    string xAxis = "Day";
    string yAxis = "Number of SMSs sent";
    string label;
    fwUi_getLabel(trees[z], trees[z], label);
    
    string dir = gWebPath + strtolower(label)+"/alarms";
      if(access(dir, W_OK))
        mkdir(dir, "777");

    file f = fopen(dir + "/smsStatistics.html", "w");
    
//DebugN("Creating file: " + dir + "/smsStatistics.html",title, xAxis, allData);    

    fputs(fwGoogleApi_columnChart(title, xAxis, allData), f);
    fclose(f);
  }
  return; 
}


int fwSysOverviewLongTermReport_getSmsHistogram(const int interval, string addressPattern, string bodyPattern, dyn_dyn_mixed &data)
{    
  dyn_mixed record;
  time startDate = getCurrentTime() - (interval*3600*24);
  anytype emailTextId;
  anytype dpId;
  anytype recipientsId;
  
  //find out the database ids that we need for the final query in order to speed up the queries:
  _fwSysOverviewLongTermReport_getDbIdsSentEmailsLog(emailTextId, dpId, recipientsId);
  string mm;
  string dd;
  string sys = getSystemName();
  sprintf(mm, "%02d", month(startDate));
  sprintf(dd, "%02d", day(startDate));
  record[1] = year(startDate)+"-"+ mm +"-"+dd;
  record[2] = emailTextId;
  record[3] = dpId;
  record[4] = recipientsId;
  
  string sTextId, sDpId, sRecipientsId;
  
  sprintf(sTextId, "%ld", emailTextId);
  sprintf(sDpId, "%ld", dpId);
  sprintf(sRecipientsId, "%ld", recipientsId);
  string query="select dt, count(*) from ( select to_char(er.ts, 'YYYY-MM-DD') dt, dp.value_string, d.value_string from eventhistory er, eventhistory d, eventhistory dp " +
               "where dp.ts > to_date(:1, \'YYYY-MM-DD\') and dp.ts = d.ts and dp.ts = er.ts and er.ts = d.ts " +
               "and d.element_id = :2 and dp.element_id = :3 and er.element_id = :4 and er.value_string like (\'%"+addressPattern+"%\') " +
               "and d.value_string like(\'%"+bodyPattern+"%\') order by dt) " +
               "group by dt order by dt";
  mixed retval = 0;
  fwDbOption("SetExactNumbers", true, retval);	  	
  
  _fwSysOverviewLongTermReport_executeQuery(query, record, data);
  
  fwDbOption("SetExactNumbers", false, retval);	  	
  
  return 0;
}

int _fwSysOverviewLongTermReport_getDbIdsSentEmailsLog(long &emailTextId, long &dpId, long &recipientsId)
{
  dyn_mixed record;
  dyn_mixed data;
  string sys = getSystemName();
  record[1] = sys + "fwSystemOverviewSentEmailsLog.emailText";
  record[2] = sys + "fwSystemOverviewSentEmailsLog.alarmsDpes";
  record[3] = sys + "fwSystemOverviewSentEmailsLog.recipients";
  
  string query="select element_id, element_name from elements where element_name in (:1, :2, :3)";
  mixed retval = 0;
  fwDbOption("SetExactNumbers", true, retval);	  	
  
  _fwSysOverviewLongTermReport_executeQuery(query, record, data);
  fwDbOption("SetExactNumbers", false, retval);	  	
  
  for(int i = 1; i<= dynlen(data); i++)
  {
//    if(data[i][2] == record[1])      emailTextId = (long) data[i][1];
//    else if(data[i][2] == record[2]) dpId = (long)data[i][1];
//    else if(data[i][2] == record[3]) recipientsId = (long)data[i][1];
    if(data[i][2] == record[1])      emailTextId = data[i][1];
    else if(data[i][2] == record[2]) dpId = data[i][1];
    else if(data[i][2] == record[3]) recipientsId = data[i][1];
  }
  return 0;
}


void fwSysOverviewLognTermReport_generateTreeAlarmHistogramPerType()
{    
  dyn_dyn_mixed data;
  dyn_int internalTypes;
  dyn_string trees;
  dyn_string applications;
  //dyn_string dpTypePatterns= makeDynString("FwFMC", "IcemonPlc", "IcemonSystemIntegrity", "FwSystemOverview");
  mapping m;
  dyn_dyn_mixed allData;
  dyn_mixed dates;
  fwSystemOverviewFsm_getTrees(trees);

  //
  m["FwFMC"] = "Data Servers";
  m["FwSystemOverview"] = "PVSS Projects";
  m["IcemonPlc"] = "PLCs";
  m["IcemonSystemIntegrity"] = "Distributed Conn.";
  m["IcemonFec"] = "FECs";
  
  for(int z = 1; z <=dynlen(trees); z++)
  {
    dynClear(allData);
    dynClear(dates);
    string label;
    fwUi_getLabel(trees[z], trees[z], label);
    applications = fwCU_getChildren(internalTypes, trees[z]);
    allData[1][1] = "Date";
    for(int i = 1; i <= interval; i++)  
    {
      time t = getCurrentTime() - (interval-i)*3600*24;
      string str;
      sprintf(str, "%04d-%02d-%02d", year(t), month(t),day(t));
//      allData[i+1][1] = str;
      dynAppend(dates, str);
    }
  
    for(int k = 1; k <= dynlen(applications);k++)
    {
      string appLabel;
      fwUi_getLabel(applications[k], applications[k], appLabel);
      dynClear(allData);
      allData[1][1] = "Date";
      for(int j =1; j <= dynlen(dates); j++)
      {
        allData[j+1][1] = dates[j];
      }
      
      dyn_string types = mappingKeys(m);
      for(int i = 1; i <= dynlen(types); i++)
      {
        dynClear(data);
        fwSysOverviewLongTermReport_getAlarmHistogramPerType(applications[k], types[i], interval, data);
        if(dynlen(data))//add application to histogram only if there were SMSs.
          _fwGoogleApi_addColumnToHistogramData(m[types[i]], data, allData);
     }  
  
      string title = applications[k] + " alarm time distribution and alarm type";
      string xAxis = "Date";
      string dir = gWebPath + strtolower(label) + "/alarms";
      if(access(dir, W_OK))
        mkdir(dir, "777");

      file f = fopen(dir +"/" + appLabel+ "_alarmsPerType.html", "w");
      fputs(fwGoogleApi_columnChart(title, xAxis, allData), f);
      fclose(f);
    }
  }
  return;
}

int fwSysOverviewLongTermReport_getAlarmHistogramPerType(string application, string dptype, const int interval, dyn_dyn_mixed &data)
{    
  dyn_mixed record;
  time startDate = getCurrentTime() - (interval*3600*24);
  string date;
  sprintf(date, "%04d-%02d-%02d", year(startDate), month(startDate), day(startDate));
  string sys = getSystemName();
  strreplace(sys, ":", "");
  string query="select dt, count(element_name) from (select element_name, to_char(ts, 'YYYY-MM-DD') dt " +
               "from (select * from alerthistory where element_id in (select element_id from elements where sys_id = (select sys_id from systems where sys_name = \'"+sys+"\') " +
               "and dpt_id in (select dpt_id from dpt where dptname like (\'%"+dptype+"%\')) and comment_ like (\'%(" + application + ")%\')) order by ts desc) ah, elements e "
               "where ts > to_date(\'"+date+"\', 'YYYY-MM-DD') and ah.element_id = e.element_id and direction = 1) "+
               "group by dt order by dt";
  _fwSysOverviewLongTermReport_executeQuery(query, record, data);
  
//DebugN(query, data);

  return 0;
}

void fwSysOverviewLongTermReport_generateTreeAlarmHistogram()
{
  dyn_dyn_mixed data;
  dyn_int types;
  dyn_dyn_mixed allData;

  dyn_string trees;
  fwSystemOverviewFsm_getTrees(trees);

  for(int z = 1; z <= dynlen(trees); z++)
  {
    dynClear(allData);
    allData[1][1] = "Date";
    for(int i = 1; i <= interval; i++)  
    {
      time t = getCurrentTime() - (interval-i)*3600*24;
      string str;
      sprintf(str, "%04d-%02d-%02d", year(t), month(t),day(t));
      allData[i+1][1] = str;
    }
  
    dyn_string applications = fwCU_getChildren(types, trees[z]);
    string label;
    fwUi_getLabel(trees[z], trees[z], label);
    for(int i = 1; i <= dynlen(applications); i++)
    {
      dynClear(data);
      fwSysOverviewLongTermReport_getAlarmHistogram(applications[i], interval, data);
    
      if(dynlen(data))//add application to histogram only if there were SMSs.
        _fwGoogleApi_addColumnToHistogramData(applications[i], data, allData);
   }  
  
    string title = label + " alarm time distribution per application";
    string xAxis = "Date";
    string dir = gWebPath + strtolower(label) + "/alarms";
    if(access(dir, W_OK))
      mkdir(dir, "777");

    file f = fopen(dir + "/alarmsPerApplication.html", "w");
    fputs(fwGoogleApi_columnChart(title, xAxis, allData), f);
    fclose(f);
 }
 return;
}

/*
int fwSysOverviewLongTermReport_getAlarmHistogram(string application, const int interval, dyn_dyn_mixed &data)
{    
  dyn_mixed record;
  time startDate = getCurrentTime() - (interval*3600*24);
  string date;
  sprintf(date, "%04d-%02d-%02d", year(startDate), month(startDate), day(startDate));
  string sys = getSystemName();
  strreplace(sys, ":", "");
  string query="select dt, count(element_name) from (select element_name, to_char(ts, 'YYYY-MM-DD') dt " +
               "from (select * from alerthistory where element_id in (select element_id from elements where sys_id = (select sys_id from systems where sys_name = \'"+sys+"\') " +
               "and comment_ like (\'%(" + application + ")%\')) order by ts desc) ah, elements e "
               "where ts > to_date(\'"+date+"\', 'YYYY-MM-DD') and ah.element_id = e.element_id and direction = 1) "+
               "group by dt order by dt";
  _fwSysOverviewLongTermReport_executeQuery(query, record, data);

  return;
}
*/
void fwSysOverviewLongTermRport_generateAlarmOverviewHistogram()
{    
  dyn_int types;
  dyn_string applications;
  fwSystemOverviewFsm_getTrees(applications);
  dyn_dyn_mixed allData;
  dyn_mixed data;
  
  allData[1][1] = "Date";
  for(int i = 1; i <= interval; i++)  
  {
    time t = getCurrentTime() - (interval-i)*3600*24;
    string str;
    sprintf(str, "%04d-%02d-%02d", year(t), month(t),day(t));
    allData[i+1][1] = str;
  }
  
  for(int i = 1; i <= dynlen(applications); i++)
  {
    fwUi_getLabel(applications[i], applications[i], applications[i]);
    dynClear(data);
    fwSysOverviewLongTermReport_getAlarmHistogram(applications[i], interval, data);
    
    if(dynlen(data))//add application to histogram only if there were SMSs.
      _fwGoogleApi_addColumnToHistogramData(applications[i], data, allData);
 }  

  //Add total to plot:  
  fwSysOverviewLongTermReport_getAlarmHistogram("", interval, data);
    
  if(dynlen(data))//add application to histogram only if there were SMSs.
    _fwGoogleApi_addColumnToHistogramData("Total", data, allData);
  
  
  string title = "Alarm time distribution per client";
  string xAxis = "Date";
  string yAxis = "Number of Alarms triggered";
  string dir = gWebPath + "alarms";
  if(access(dir, W_OK))
    mkdir(dir, "777");
  
//  DebugN("Generating file: " + dir + "/overallAlarmStatistics.html");
  file f = fopen(dir + "/overallAlarmStatistics.html", "w");
  fputs(fwGoogleApi_comboChart(title, xAxis, yAxis, allData), f);
  fclose(f);
 
 return;
}

int fwSysOverviewLongTermReport_getAlarmHistogram(string application, const int interval, dyn_dyn_mixed &data)
{    
  dyn_mixed record;
  time startDate = getCurrentTime() - (interval*3600*24);
  string date;
  sprintf(date, "%04d-%02d-%02d", year(startDate), month(startDate), day(startDate));
  string sys = getSystemName();
  strreplace(sys, ":", "");
  string query;
  
  
  if(application != "")
    query="select dt, count(element_name) from (select element_name, to_char(ts, 'YYYY-MM-DD') dt " +
               "from (select * from alerthistory where element_id in (select element_id from elements where sys_id = (select sys_id from systems where sys_name = \'"+sys+"\') " +
               "and comment_ like (\'%(" + application + ")%\')) order by ts desc) ah, elements e "
               "where ts > to_date(\'"+date+"\', 'YYYY-MM-DD') and ah.element_id = e.element_id and direction = 1) "+
               "group by dt order by dt";
  else
    query="select dt, count(element_name) from (select element_name, to_char(ts, 'YYYY-MM-DD') dt " +
               "from (select * from alerthistory where element_id in (select element_id from elements where sys_id = (select sys_id from systems where sys_name = \'"+sys+"\') " +
               ") order by ts desc) ah, elements e "
               "where ts > to_date(\'"+date+"\', 'YYYY-MM-DD') and ah.element_id = e.element_id and direction = 1) "+
               "group by dt order by dt";
    
  _fwSysOverviewLongTermReport_executeQuery(query, record, data);
//DebugN(query, data);  

  return 0;
}

void fwSysOverviewLongTermReport_alarmsMainPage(const int x = 1000, const int y = 500)
{
  string date = getCurrentTime();
  date = substr(date, 0, strlen(date)-7);
  string html = "<title>MOON Alarm Statistics</title>";
         html += "<h1 style=\"font:18px Verdana, Arial, Helvetica, sans-serif\" align=\"left\">MOON Alarm Statistics</h1>";
         html += "<p style=\"font:12px Verdana, Arial, Helvetica, sans-serif\">This page shows the total number of alarms raised by MOON per client. Detailed statistics for each client are also available:</p>";
         html += "<p align=\"right\" style=\"font:12px Verdana, Arial, Helvetica, sans-serif\"><strong>Content generated on "+date+"</strong></p>";
         html += "    <ul style=\"font:12px Verdana, Arial, Helvetica, sans-serif\">";
         dyn_string trees;
         fwSystemOverviewFsm_getTrees(trees);
         for(int i = 1; i <= dynlen(trees); i++)
         {
           string label;
           fwUi_getLabel(trees[i], trees[i], label);
           html += "      <li><a href=\"../"+strtolower(label)+"/alarms/alarmStatistics.html\">"+label+"</a></li>";
         }
         html += "    </ul>";
         html += "<div>";
         html += "  <iframe height=\""+y+"\" width=\""+x+"\" scrolling=\"no\" frameborder=\"0\" src=\"overallAlarmStatistics.html\"></iframe>";
         html += "</div>";
 
  string dir = gWebPath + "alarms";       
  if(access(dir, W_OK))
    mkdir(dir, "777");
  
  file f = fopen(dir + "/alarmStatistics.html", "w+");
  fputs(html, f);
  fclose(f); 
  
  return;
}

void fwSysOverviewLongTermReport_generateTreesMainPages()
{
  dyn_string trees;
  fwSystemOverviewFsm_getTrees(trees);
  for(int i = 1; i <= dynlen(trees);i++)
  {
    fwSysOverviewLongTermReport_alarmsTreeMainPage(trees[i]);
  }
}

void fwSysOverviewLongTermReport_generateTreeAlarmSummary(string tree, const int x = 1000, const int y = 500)
{
  string date = getCurrentTime();
  date = substr(date, 0, strlen(date)-7);
  string label;
  fwUi_getLabel(tree, tree, label);
  string html= "<h1 style=\"font:18px Verdana, Arial, Helvetica, sans-serif\"><strong>"+label+" Alarm Statistics</strong></strong></h1>";
  html += "<p align=\"right\" style=\"font:12px Verdana, Arial, Helvetica, sans-serif\"><strong>Content generated on "+date+"</strong></p>";
  html += "<p style=\"font:12px Verdana, Arial, Helvetica, sans-serif\">The plots below offer an overview of the alarms generated by MOON for the <strong>" + label + "</strong> client over the last <strong>"+interval+"</strong> days. The following statistics are given:</p>";
  html += "<ul style=\"font:12px Verdana, Arial, Helvetica, sans-serif\">";
  html += "<li>Alarm time distribution per application</li>";
  html += "<li>SMS time distribution per application</li>";
  html += "<li>List of most recurrent alarms</li>";
  html += "<li>List of longest living alarms</li>";
  html += "</ul>";
  html += "<p style=\"font:12px Verdana, Arial, Helvetica, sans-serif\">For detailed statistics per application, click on the application menu on the left</a></p>";
  html += "</p>";
  html += "<br />";
  html += "<div>";
  html += "<iframe width=\""+x+"\" height=\""+400+"\" frameborder=\"0\" scrolling=\"no\" src=\"applicationAlarmDistribution.html\"></iframe>";
  html += "</div>";
  html += "<br />";
  html += "<div>";
  html += "<iframe width=\""+x+"\" height=\""+y+"\" frameborder=\"0\" scrolling=\"no\" src=\"alarmsPerApplication.html\"></iframe>";
  html += "</div>";
  html += "<br />";
  html += "<div>";
  html += "<iframe width=\""+x+"\" height=\""+y+"\" frameborder=\"0\" scrolling=\"no\" src=\"smsStatistics.html\"></iframe>";
  html += "</div>";
  html += "<br />";
  html += "<div><font face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Most recurrent alarms</strong></font>";
  html += "<br />";
  html += "<iframe width=\""+x+"\" height=\""+y+"\" frameborder=\"0\" scrolling=\"no\" src=\"recurrentAlarms.html\"></iframe>";
  html += "</div>";
  html += "<br />";
  html += "<div><font face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Longest living alarms</strong></font>";
  html += "<br />";
  html += "<iframe width=\""+x+"\" height=\""+y+"\" frameborder=\"0\" scrolling=\"no\" src=\"longestLivingAlarms.html\"></iframe>";
  html += "</div>";

  string treeLabel;
  fwUi_getLabel(tree, tree, treeLabel);
  string dir = gWebPath + strtolower(treeLabel) + "/alarms";       
  if(access(dir, W_OK))
    mkdir(dir, "777");
  
  file f = fopen(dir + "/treeAlarmSummary.html", "w+");
  if(f > 0)
  {
    fputs(html, f);
    fclose(f); 
  }
  else
  {
DebugN("WebGen: Problem opening file " + dir + "/treeAlarmSummary.html" + " for writing...");
  }
  
  return;
}


void fwSysOverviewLongTermReport_alarmsTreeMainPage(string tree, const int x = 1000, const int y = 500)
{
  dyn_int internalTypes;
  dyn_string applications = fwCU_getChildren(internalTypes, tree); 
  fwSysOverviewLongTermReport_generateTreeAlarmSummary(tree, x, y);
  string html;
  html =   "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\n"+
           "<html xmlns=\"http://www.w3.org/1999/xhtml\">\n"+
           "<head>\n"+
           "<meta content=\"text/html; charset=iso-8859-1\" http-equiv=\"Content-Type\" />\n"+
           "<title>Alarm Statistics</title>\n"+
           "<link href=\"../../styles/styles.css\" rel=\"stylesheet\" type=\"text/css\" />\n"+
           "<style type=\"text/css\">html, body, iframe { margin:0; padding:0; height:100%; width:100%}iframe { display:block; width:100%; border:none; }\n"+
           "</style>\n"+
           "<script type=\"text/javascript\" src=\"../../scripts/scripts.js\"></script>\n"+
           "</head>\n"+
           "<body onload=\"loadLong('Overview')\">\n"+
           "<table style=\"height:95%\">\n"+
           "<tr style=\"align: right; valign: bottom\">\n"+
           "<td colspan=\"3\">\n"+
           "<ul id=\"nav\">\n"+
           "<li id=\"nav-1\"><a href=\"../../tree/"+tree+".xml\">Overview</a></li>\n"+
           "<li id=\"nav-2\"><a href=\"../moonAlarms.html\">Alarms</a></li>\n"+
           "<li id=\"nav-3\"><a href=\"../reportsDaily/dailyReports.html\">Daily reports</a></li>\n"+
           "<li id=\"nav-3\"><a href=\"../reportsLong/longTermReports.html\">Long-term reports</a></li>\n"+
           "<li id=\"nav-4\" class=\"current\"><a href=\"#\">Alarm Statistics</a></li>\n"+
           ((tree == "fwSO_LHC_Applications")?"<li id=\"nav-5\"><a href=\"../../cgi-bin/ns.cgi\">Notifications Subscriptions</a></li>":"")+
           "</ul>\n"+
           "</td>\n"+
           "</tr>\n"+
           "<tr valign=\"top\">\n"+
           "<td style=\"width: 10%; align: left\">\n";
  
  if (dynlen(applications) > 0)
  {
    html += "<ul id=\"menu\">\n";
    html += "<li id=\"Overview\"  width=\"100%\" onclick=\"changeSelectionLong('Overview')\"><a href=\"treeAlarmSummary.html\" target=\"treeAlarmSummaryFrame\">Overview</a></li>\n";
    for(int i=1; i<=dynlen(applications);i++)
    {
      string label;
      fwUi_getLabel(applications[i], applications[i], label);
//      html += "<li id=\"" + applications[i] + "\" onclick=\"changeSelectionLong('" +  applications[i]  + "')\"><a href=\"" +  applications[i]  + ".html\" target=\"reportsFrame\">" + label + "</a></li>";
      html += "<li id=\"" + applications[i] + "\" width=\"100%\" onclick=\"changeSelectionLong('" +  applications[i]  + "')\"><a href=\"" +  label  + "_alarmsPerType.html\" target=\"treeAlarmSummaryFrame\">" + label + "</a></li>\n";
    }
	
    html += "</ul>\n";
  }
  html += "</td>\n";
  html += "<td style=\"width: 90%;height:100%\">";
  html += "<iframe src=\"treeAlarmSummary.html\" scrolling=\"auto\" id=\"treeAlarmSummaryFrame\" name=\"treeAlarmSummaryFrame\" frameborder=\"0\"></iframe>";
  html += "</td>";

  html += "</tr>\n";
  html += "</table>\n";
  html += "</body>";
  html += "</html>";

  string treeLabel;
  fwUi_getLabel(tree, tree, treeLabel);
  string dir = gWebPath + strtolower(treeLabel) + "/alarms";       
  if(access(dir, W_OK))
    mkdir(dir, "777");
  
  file f = fopen(dir + "/alarmStatistics.html", "w+");
  fputs(html, f);
  fclose(f); 
  
  return;
}

string fwGoogleApi_getDataMatrix(dyn_dyn_mixed data, bool useQuotesOnFirstColumn = true)
{  
  if(dynlen(data)<=0)
    return "[[]]";
  
  string html = "[[";
  for(int i = 1; i< dynlen(data[1]); i++)
  {
      html += "\'" + data[1][i] + "\', ";
    
  }
  if(useQuotesOnFirstColumn)
    html += "\'" + data[1][dynlen(data[1])] + "\'],";
  else
    html += data[1][dynlen(data[1])] + "],";
    
  for(int i = 2; i < dynlen(data); i++)
  {
    html += "[\'" + data[i][1] + "\'"; 
    
    for(int j = 2; j <= dynlen(data[i]); j++)
    {
      html += ", " + data[i][j];
    }
    html += "],";
  }
  
  html += "[\'" + data[dynlen(data)][1] + "\'"; 
  for(int j = 2; j <= dynlen(data[dynlen(data)]); j++)
  {
    html += ", " + data[dynlen(data)][j];
  }
  html += "]";

  html += "]";
  
  return html;
}


string fwGoogleApi_pieChart(string title, dyn_dyn_mixed data, int x = 800, int y= 400)
{
  string html = "<html>";
  html += " <head>";
  html += "   <script type=\"text/javascript\" src=\"https://www.google.com/jsapi\"></script>";
  html += "   <script type=\"text/javascript\">";
  html += "     google.load(\"visualization\", \"1\", {packages:[\"corechart\"]});";
  html += "     google.setOnLoadCallback(drawChart);";
  html += "     function drawChart() {";
  html += "       var data = google.visualization.arrayToDataTable(";
  html += fwGoogleApi_getDataMatrix(data, false);
  html += "       );";
  html += "        var options = {";
  html += "          chartArea:{left:100},";
  html += "          title: \'"+title+"\'";
  html += "        };";
  html += "        var chart = new google.visualization.PieChart(document.getElementById(\'chart_div\'));";
  html += "        chart.draw(data, options);";
  html += "      }";
  html += "    </script>";
  html += "  </head>";
  html += "  <body>";
  html += "    <div id=\"chart_div\" style=\"width: "+x+"px; height: "+y+"px;\"></div>";
  html += "  </body>";
  html += "</html>";

  
  return html;
}


void fwGoogleApi_tableAddColumn(string name, string type, string &data)
{    
  if(data == "")
   data = "       var data = new google.visualization.DataTable();";
          
  data += "       data.addColumn(\'"+type+"\', \'"+name+"\');";
  
  return;
}

int fwGoogleApi_tableAddRows(dyn_dyn_string rows, string &data)
{
  data += "       data.addRows([";
  
  if(dynlen(rows)<=0)
  {
    data += "[\'No data available\']]);"; 
    return data; 
  }
  
  for(int i =1; i <= dynlen(rows); i++)
  {  
    data += "[";
    for(int j = 1; j < dynlen(rows[i]); j++)
    {
      data += "\'"+rows[i][j]+"\',";
    }
    
   if(i == dynlen(rows)) 
    data += "\'"+rows[i][dynlen(rows[i])]+ "\']]);";
   else
    data += "\'"+rows[i][dynlen(rows[i])]+ "\'],";
  }            
   return 0;
}

//data
//data[1] contains the column headers

string fwGoogleApi_getTableData(dyn_string headers, dyn_dyn_mixed data)
{
  
  string html;
  for(int i = 1; i <= dynlen(headers); i++)  
    fwGoogleApi_tableAddColumn(headers[i], "string", html);
  
  fwGoogleApi_tableAddRows(data, html);

  return html;
}

string fwGoogleApi_table(dyn_string columnHeaders, dyn_dyn_mixed data)
{
  string html = "<html>";
  html+= " <head>";
  html+= "   <script type=\'text/javascript\' src=\'https://www.google.com/jsapi\'></script>";
  html+= "   <script type=\'text/javascript\'>";
  html+= "     google.load(\'visualization\', \'1\', {packages:[\'table\']});";
  html+= "     google.setOnLoadCallback(drawTable);";
  html+= "     function drawTable() {";
  html+= fwGoogleApi_getTableData(columnHeaders, data);
 
  html+= "       var table = new google.visualization.Table(document.getElementById(\'table_div\'));";
  html+= "       table.draw(data, {showRowNumber: true});";
  html+= "     }";
  html+= "   </script>";
  html+= " </head>";
 
  html+= " <body>";
  html+= "   <div id=\'table_div\'></div>";
  html+= " </body>";
  html+= "</html>";
  
  return html;
}


string fwGoogleApi_comboChart(string title, string xAxis, string yAxis, dyn_dyn_mixed data, int x = 1000, int y= 500)
{
  string html = "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">";
  html += "<html xmlns=\"http://www.w3.org/1999/xhtml\">";
  html += " <head>";
  html += "   <meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\"/>";
  html += "   <title>";
  html += "     " + title;
  html += "   </title>";
  html += "   <script type=\"text/javascript\" src=\"https://www.google.com/jsapi\"></script>";
  html += "   <script type=\"text/javascript\">";
  html += "     google.load('visualization', '1', {packages: ['corechart']});";
  html += "   </script>";
  html += "   <script type=\"text/javascript\">";
  html += "     function drawVisualization() {";
  html += "       var data = google.visualization.arrayToDataTable(";
  
  html += fwGoogleApi_getDataMatrix(data);  
  html += ");";  
  html += "       var options = {";
  html += "         chartArea:{left:100},";
  html += "         title : '"+title+"',";
  html += "         vAxis: {title: \""+yAxis+"\"},";
  html += "         hAxis: {title: \""+xAxis+"\"},";
  html += "         seriesType: \"bars\",";
  html += "         series: {5: {type: \"line\"}}";
  html += "       };";
 
  html += "       var chart = new google.visualization.ComboChart(document.getElementById('chart_div'));";
  html += "       chart.draw(data, options);";
  html += "     }";
  html += "     google.setOnLoadCallback(drawVisualization);";
  html += "   </script>";
  html += " </head>";
  html += " <body>";
  html += "   <div id=\"chart_div\" style=\"width: "+x+"px; height: "+y+"px;\"></div>";
  html += " </body>";
  html +=  "</html>";
 
 return html;
 
}

string fwGoogleApi_lineChart(string title, dyn_dyn_mixed data, int x = 1000, int y= 500)
{
  string html = "<html>";
  html += " <head>";
  html += "   <script type=\"text/javascript\" src=\"https://www.google.com/jsapi\"></script>";
  html += "   <script type=\"text/javascript\">";
  html += "     google.load(\"visualization\", \"1\", {packages:[\"corechart\"]});";
  html += "     google.setOnLoadCallback(drawChart);";
  html += "     function drawChart() {";
  html += "       var data = google.visualization.arrayToDataTable(";
  html += fwGoogleApi_getDataMatrix(data);  
  html += "       );"; 
  html += "       var options = {";
  html += "         chartArea:{left:100},";
  html += "         title: \'"+title+"\'";
  html += "       };"; 
  html += "       var chart = new google.visualization.LineChart(document.getElementById(\'chart_div\'));";
  html += "       chart.draw(data, options);";
  html += "     }";
  html += "   </script>";
  html += " </head>";
  html += " <body>";
  html += "   <div id=\"chart_div\" style=\"width: "+x+"px; height: "+y+"px;\"></div>";
  html += " </body>";
  html += "</html>";
 
 return html;
 
}

string fwGoogleApi_areaChart(string title, string xAxis, dyn_dyn_mixed data, int x = 1000, int y= 500)
{
  string html = "<html>";
  html += " <head>";
  html += "   <script type=\"text/javascript\" src=\"https://www.google.com/jsapi\"></script>";
  html += "   <script type=\"text/javascript\">";
  html += "     google.load(\"visualization\", \"1\", {packages:[\"corechart\"]});";
  html += "     google.setOnLoadCallback(drawChart);";
  html += "     function drawChart() {";
  html += "       var data = google.visualization.arrayToDataTable(";
  html += fwGoogleApi_getDataMatrix(data);    
  html += "       );";
  html += "       var options = {";
  html += "         chartArea:{left:100},";
  html += "         title: \'"+title+"\',";
  html += "         hAxis: {title: \'"+xAxis+"\',  titleTextStyle: {color: \'red\'}}";
  html += "       };";
  html += "       var chart = new google.visualization.AreaChart(document.getElementById(\'chart_div\'));";
  html += "       chart.draw(data, options);";
  html += "     }";
  html += "   </script>";
  html += " </head>";
  html += " <body>";
  html += "   <div id=\"chart_div\" style=\"width: "+x+"px; height: "+y+"px;\"></div>";
  html += " </body>";
  html += "</html>";
 
 return html;
 
}

string fwGoogleApi_columnChart(string title, string xAxis, dyn_dyn_mixed data, int x = 1000, int y= 500)
{
  string html = "<html>";
  html += "<head>";
  html += "   <script type=\"text/javascript\" src=\"https://www.google.com/jsapi\"></script>";
  html += "   <script type=\"text/javascript\">";
  html += "     google.load(\"visualization\", \"1\", {packages:[\"corechart\"]});";
  html += "     google.setOnLoadCallback(drawChart);";
  html += "     function drawChart() {";
  html += "       var data = google.visualization.arrayToDataTable(";
  html += fwGoogleApi_getDataMatrix(data);  
  html += "       );";
 
  html += "       var options = {";
  html += "         chartArea:{left:100},";
  html += "         title: \'"+title+"\',";
  html += "         hAxis: {title: \'"+xAxis+"\', titleTextStyle: {color: \'red\'}}";
  html += "       };";
 
  html += "       var chart = new google.visualization.ColumnChart(document.getElementById(\'chart_div\'));";
  html += "       chart.draw(data, options);";
  html += "     }";
  html += "   </script>";
  html += " </head>";
  html += " <body>";
  html += "   <div id=\"chart_div\" style=\"width: "+x+"px; height: "+y+"px;\"></div>";
  html += " </body>";
  html += "</html>";
 
 return html;
}

string fwGoogleApi_barChart(string title, string xAxis, dyn_dyn_mixed data, int x = 1000, int y= 500)
{
  string html = "<html>";
  html += " <head>";
  html += "   <script type=\"text/javascript\" src=\"https://www.google.com/jsapi\"></script>";
  html += "   <script type=\"text/javascript\">";
  html += "     google.load(\"visualization\", \"1\", {packages:[\"corechart\"]});";
  html += "     google.setOnLoadCallback(drawChart);";
  html += "     function drawChart() {";
  html += "       var data = google.visualization.arrayToDataTable(";
  html += fwGoogleApi_getDataMatrix(data);  
  html += "       );";
  html += "       var options = {";
  html += "         chartArea:{left:100},";
  html += "         title: \'" + title + "\',";
  html += "         vAxis: {title: \'" + xAxis + "\',  titleTextStyle: {color: \'red\'}}";
  html += "       };";
  html += "       var chart = new google.visualization.BarChart(document.getElementById(\'chart_div\'));";
  html += "       chart.draw(data, options);";
  html += "     }";
  html += "   </script>";
  html += " </head>";
  html += " <body>";
  html += "   <div id=\"chart_div\" style=\"width: "+x+"px; height: "+y+"px;\"></div>";
  html += " </body>";
  html += "</html>";
 
 return html;
}


_fwGoogleApi_addColumnToHistogramData(string application, dyn_dyn_mixed data, dyn_dyn_mixed &allData)
{
  int newColIdx = dynlen(allData[1])+1;
  allData[1][newColIdx] = application;
  for(int k = 2; k <= dynlen(allData); k++)
  {
    int pos = -1;
    for(int j = 1; j <= dynlen(data); j++)
    {
      if(allData[k][1] == data[j][1])
      {
        pos = j;
        break;
      }
    }
    
    if(pos > 0)
    {
      allData[k][newColIdx] = (int)data[pos][2];
    }
    else
    {
      allData[k][newColIdx] = 0;
    }
  }
  return;  
}
//////////////////////////////////////////End of alarm statistics//////////////////////////////



int _fwSysOverviewLongTermReport_getPlotsPerChart()
{
  int plotsPerChart;
  dpGet("fwSystemOverviewReportsConfig.longTerm.plotsPerChart", plotsPerChart);
  return plotsPerChart;
}

int _fwSysOverviewLongTermReport_getReportPeriod()
{
  int reportPeriod;
  dpGet("fwSystemOverviewReportsConfig.longTerm.reportPeriod", reportPeriod);
  return reportPeriod;
}
string _fwSysOverviewLongTermReport_getFilePath()
{
  string filePath;
  dpGet("fwSystemOverviewReportsConfig.filePath", filePath);
  return filePath;
}

dyn_string fwSysOverviewLongTermReport_getReportUrls(string node)
{
  string fsUrl, usedMemoryUrl, usedSwapUrl;
  string dpName = FWSYSOVERVIEWLONGTERMREPORT_REPORT_PREFIX + node;
  if (dpExists(dpName))
  { 
    dpGet(dpName + ".userMemory", usedMemoryUrl,
          dpName + ".usedSwap", usedSwapUrl,
          dpName + ".fs", fsUrl);
  }
  return makeDynString(fsUrl, usedMemoryUrl, usedSwapUrl);
}

void fwSysOverviewLongTermReport_storeChartsUrls(mapping dpeToData, time endDate, int numberOfDays)
{
  string chartProperty; // what we are plotting, i.e userMemory, usedSwap, fs, etc
  string chartCaption;
  dyn_string dpes = mappingKeys(dpeToData);
  for (int i=1; i <= dynlen(dpes); i++)
  {
    string dpName = dpSubStr(dpes[i], DPSUB_DP_EL);
    string node = fwFMC_getNodeName(dpName);
    if (node != "")
    {
      dyn_string strArr = strsplit(dpes[i], ".");
      string type = dpTypeName(dpName);
      if (type == "FwFMCFs")
      {
        chartProperty = "fs";
        chartCaption = "File System /opt";
      }
      else if (type == "FwFMCMem")
      {
        chartProperty = strArr[dynlen(strArr)];
        if (chartProperty == "userMemory")
          chartCaption = "Used Memory";
        else if (chartProperty == "usedSwap")
          chartCaption = "Used Swap";
        else
          chartCaption = chartProperty;
      }
      
      dyn_string charts = _fwSysOverviewLongTermReport_createChartUrl(dpes[i], dpeToData[dpes[i]], endDate, numberOfDays, chartCaption, "%");
      if(!dpExists(FWSYSOVERVIEWLONGTERMREPORT_REPORT_PREFIX + node))
      {
        dpCreate(FWSYSOVERVIEWLONGTERMREPORT_REPORT_PREFIX + node, FWSYSOVERVIEWLONGTERMREPORT_REPORT_DPTYPE);
      }
      
      if(dynlen(charts) > 0)
      {
        dpSet(FWSYSOVERVIEWLONGTERMREPORT_REPORT_PREFIX + node + "." + chartProperty, charts[1]);
      }
    }
      
  }
}

void fwSysOverviewLongTermReport_createLongTermReportsHtml(string tree, string filePath="")
{
  dyn_int types;
  dyn_string applications = fwCU_getChildren(types, tree);
  string html;
  html = "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">" +
           "<html xmlns=\"http://www.w3.org/1999/xhtml\">"+
           "<head>" +
           "<meta content=\"text/html; charset=iso-8859-1\" http-equiv=\"Content-Type\" />"+
           "<title>MOON</title>" +
           "<link href=\"../../styles/styles.css\" rel=\"stylesheet\" type=\"text/css\" />"+
           "<style type=\"text/css\">"+
           "html, body, iframe { margin:0; padding:0; height:100%; width:100%}"+
           "iframe { display:block; width:100%; border:none; }"+
           "</style>"+
           "<script type=\"text/javascript\" src=\"../../scripts/scripts.js\"></script>"+
           "</head>"+
           "<body onload=\"loadLong('" + applications[1] + "')\">"+
           "<table style=\"height:95%\">"+
  	       "<tr style=\"align: right; valign: bottom\">"+
    		   "<td colspan=\"2\">"+
  		     "<ul id=\"nav\">"+
  			   "<li id=\"nav-1\"><a href=\"../../tree/" + tree + ".xml\">Overview</a></li>"+
  			   "<li id=\"nav-2\"><a href=\"../moonAlarms.html\">Alarms</a></li>"+
  			   "<li id=\"nav-3\"><a href=\"../reportsDaily/dailyReports.html\">Daily reports</a></li>"+
  			   "<li id=\"nav-3\" class=\"current\"><a href=\"#\">Long-term reports</a></li>"+     
           "<li id=\"nav-4\"><a href=\"../alarms/alarmStatistics.html\">Alarm Statistics</a></li>"+
           ((tree == "fwSO_LHC_Applications")?"<li id=\"nav-5\"><a href=\"../../cgi-bin/ns.cgi\">Notifications Subscriptions</a></li>":"")+
  		     "</ul>"+
  		     "</td>"+
  	       "</tr>"+
  	       "<tr valign=\"top\">"+
  		     "<td style=\"width: 10%; align: left\">";
 
  if (dynlen(applications) > 0)
  {
    html += "<ul id=\"menu\">";
    for(int i=1; i<=dynlen(applications);i++)
    {
      string label = fwSysOverviewNotifications_getApplicationLabel(tree, applications[i]);
    
      html += "<li id=\"" + applications[i] + "\" onclick=\"changeSelectionLong('" +  applications[i]  + "')\"><a href=\"" +  applications[i]  + ".html\" target=\"reportsFrame\">" + label + "</a></li>";
    }
	
    html += "</ul>";
  }
  html += "</td>";
  html += "<td style=\"width: 90%;height:100%\">";
  html += "<iframe src=\"" +  applications[1] + ".html\" scrolling=\"auto\" id=\"reportsFrame\" name=\"reportsFrame\" frameborder=\"0\"></iframe>";
  html += "</td>";
  html += "</tr>";
  html += "</table>";
  html += "</body>";
  html += "</html>";
  string label;
  fwUi_getLabel(tree, tree, label);
  string destinationFolder = filePath==""?_fwSysOverviewLongTermReport_getFilePath():filePath;
  string destinationFolder = filePath==""?_fwSysOverviewLongTermReport_getFilePath():filePath;
  if(!isdir(destinationFolder + strtolower(label) + "/"))
    mkdir(destinationFolder + strtolower(label) + "/", "755");
  if(!isdir(destinationFolder + strtolower(label) + "/" + FWSYSOVERVIEWLONGTERMREPORT_REPORTS_FOLDER + "/"))
    mkdir(destinationFolder + strtolower(label) + "/" + FWSYSOVERVIEWLONGTERMREPORT_REPORTS_FOLDER + "/", "755");
  string filePath =  destinationFolder + strtolower(label) + "/" + FWSYSOVERVIEWLONGTERMREPORT_REPORTS_FOLDER + "/longTermReports.html";
  file f = fopen(filePath, "w+");
  int err = ferror(f);
  if (!err)
  {
    fputs(html, f);
    fclose(f);
  }
}
void fwSysOverviewLongTermReport_createApplicationReport(string application, string filePath="")
{
   int endDate = getCurrentTime();
   string html = _fwSysOverviewLongTermReport_generateCommonHtmlStart();
   int reportPeriod = _fwSysOverviewLongTermReport_getReportPeriod();
   DebugTN("fwSysOverviewLongTermReport_createApplicationUsedMemoryCharts");
   dyn_string usedMemoryCharts = fwSysOverviewLongTermReport_createApplicationUsedMemoryCharts(application, endDate, reportPeriod, plotOnTheSameChart);
   html += _fwSysOverviewLongTermReport_generateChartsHtml(usedMemoryCharts, "usedMemoryTrends");
   DebugTN("fwSysOverviewLongTermReport_createApplicationUsedSwapCharts");
   dyn_string usedSwapCharts = fwSysOverviewLongTermReport_createApplicationUsedSwapCharts(application, endDate, reportPeriod, plotOnTheSameChart);    
   html += _fwSysOverviewLongTermReport_generateChartsHtml(usedSwapCharts, "usedSwapCharts");    
   DebugTN("fwSysOverviewLongTermReport_createApplicationFSOptCharts");
   dyn_string fsOptCharts = fwSysOverviewLongTermReport_createApplicationFSOptCharts(application, endDate, reportPeriod, plotOnTheSameChart);    
   html += _fwSysOverviewLongTermReport_generateChartsHtml(fsOptCharts, "fsOptCharts");    
   DebugTN("fwSysOverviewLongTermReport_createApplicationMonitoredProcessesCharts");
   dyn_string monitoredProcessesCharts = fwSysOverviewLongTermReport_createApplicationMonitoredProcessesCharts(application, endDate, reportPeriod);    
   html += _fwSysOverviewLongTermReport_generateChartsHtml(monitoredProcessesCharts, "monitoredProcessesCharts");

   DebugTN("fwSysOverviewLongTermReport_createApplicationFecCharts");
   //dyn_string fecsCharts = fwSysOverviewLongTermReport_createApplicationFecCharts(application, endDate, reportPeriod);
   //html += _fwSysOverviewLongTermReport_generateChartsHtml(fecsCharts, "FECsCharts");
   DebugTN("Finishing long-term reports for application " + application + ". All data have been queried.");
   
   html += _fwSysOverviewLongTermReport_generateCommonHtmlEnd();
   

   string path;
   int type;
   string parent =  fwCU_getParent(type, application);
   string destinationFolder = filePath==""?_fwSysOverviewLongTermReport_getFilePath():filePath;
   if (parent != "")
   {
     string label;
     fwUi_getLabel(parent, parent, label);
     if (!isdir(destinationFolder + strtolower(label) + "/"))
       mkdir(destinationFolder + strtolower(label) + "/", "755");
     if(!isdir(destinationFolder + strtolower(label)+"/" + FWSYSOVERVIEWLONGTERMREPORT_REPORTS_FOLDER + "/"))
       mkdir(destinationFolder + strtolower(label)+"/" + FWSYSOVERVIEWLONGTERMREPORT_REPORTS_FOLDER + "/" , "755");
     path =  destinationFolder + strtolower(label) + "/" + FWSYSOVERVIEWLONGTERMREPORT_REPORTS_FOLDER + "/";
   } 
   else    
   {
     if (!isdir(destinationFolder + "/" +FWSYSOVERVIEWLONGTERMREPORT_REPORTS_FOLDER + "/"))
       mkdir(destinationFolder + "/" +FWSYSOVERVIEWLONGTERMREPORT_REPORTS_FOLDER + "/", "755" );
     path =  destinationFolder + "/" +FWSYSOVERVIEWLONGTERMREPORT_REPORTS_FOLDER + "/";
   }   
   file f = fopen(path + application + ".html", "w+");
   int err = ferror(f);
   if (!err)
   {
     fputs(html, f);
     fclose(f);
   }
  
}

string _fwSysOverviewLongTermReport_generateCommonHtmlStart()
{
  string html;
  html += "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\"";
  html += "http://www.w3.org/TR/html4/loose.dtd\">";
  html += "<html>";
  html += "<head>";
  html += "<title>MOON</title>";
  html += "</head>";
  html += "<body>";
  html +="<div id=\"trends\" style = \"float:right;width:100% \">";
  return html;
}
string _fwSysOverviewLongTermReport_generateCommonHtmlEnd()
{
  string html;
  html += "</div>";
  html += "</td>";
  html += "</tr>";
  html += "</table>";
  html += "</body>";
  html += "</html>";
  return html;
}
string _fwSysOverviewLongTermReport_generateChartsHtml(dyn_string charts, string htmlId)
{
  string html = "<div id=\"" + htmlId + "\">" ;
  for (int i=1; i<= dynlen(charts); i++)
  {
    html += "<img alt=\"cht\" src='" + charts[i] + "' >";
  }
  html += "</div>";
  return html;
}

dyn_string _fwSysOverviewLongTermReport_createApplicationFMCNodeMemCharts(string application, time endDate, int days, string dpeEnding, string chartTitle, bool plotOnTheSameChart = true)
{
  dyn_string chartUrls;
  dyn_string memoryDps;
  dyn_dyn_mixed data;
  dyn_dyn_string dps = fwSysOverviewFsm_getChildrenOfTypeWithDomain(application, "FwFMCNode", application);   
  for(int i = 1; i <= dynlen(dps); i++)
  {
    string memoryDp = dps[i][1] + dpeEnding;
    dynAppend(memoryDps, memoryDp);
  }
  
  int rc = fwSysOverviewLongTermReport_getAverageDataOverTime(endDate, days, memoryDps, data);
  if (rc==0)
  {
    _fwSysOverviewLongTermReport_prepareDataMultipleDp(endDate, days, memoryDps, data);
    //DebugN(data);
    chartUrls = _fwSysOverviewLongTermReport_createChartUrl(memoryDps, data, endDate, days, chartTitle,"%", plotOnTheSameChart);
    //DebugN(chartUrls);
  }
 
  return chartUrls;
}

//the purpose of this method is to provide enpugh data to make a plot, i.e. if there is none or only one archived values for the period it adds the current value
void _fwSysOverviewLongTermReport_prepareData(time endDate, int days, string dpe, dyn_dyn_mixed& data)
{
  string originalDpe = dpe;
  
  dpe = dpSubStr(dpe, DPSUB_SYS_DP_EL);
  int rowsCount = dynlen(data);
  time startDate = (int)endDate - (days-1)*24*60*60;
  string start = formatTime("%d/%m/%Y", startDate);
  string end = formatTime("%d/%m/%Y", endDate);
  float currentVal;
  int ret = dpGet(dpe, currentVal);
  if(ret)
  {
    dyn_errClass err = getLastError();
    DebugN("Failed to do dpGet of " + dpe + " Error message: " + err);
    DebugN("getStackTrace",getStackTrace(), endDate, days, dpe, originalDpe);
  }
  //round to 1 digit after decimal
  string tmpStr;
  sprintf(tmpStr, "%3.2f", currentVal);
  currentVal = tmpStr;
  if (rowsCount == 0)// we don't have any archived data => just add the current value as start and end value
  {
    data[1] = makeDynString(start, currentVal, dpe);
    data[2] = makeDynString(end, currentVal, dpe);
  }  
  else if (rowsCount == 1)//we don't have enough data to plot 
  {
    if (data[1][1] != end)//if the data is not for the last day->add current value as an end date value
    {
      data[2] = makeDynString(end, currentVal, dpe);
     
    }
    else //put the value as a start value
    {
      dyn_string tmp = data[1];
      data[1] = makeDynString(start, data[1][2], dpe);
      data[2] = tmp;
    }
  }
  else if (data[dynlen(data)][1] != end) // if we don't have data for the last day ->add the current value
  {
    data[dynlen(data) + 1] = makeDynString(end, currentVal, dpe);
   
  }  
 

}

void _fwSysOverviewLongTermReport_prepareDataMultipleDp(time endDate, int days, dyn_string dpes, dyn_dyn_mixed& data, bool store = true)
{
  mapping dpeToData;
  dyn_dyn_mixed newData;
  if (dynlen(data) > 0)
  {
    dyn_dyn_mixed portionedData = _fwSysOverviewLongTermReport_portionData(data, 1);
    dpeToData = _fwSysOverviewLongTermReport_makeMapping(portionedData);
    dyn_string dpesWithData = mappingKeys(dpeToData);
    for(int i=1; i<=dynlen(dpes);i++)
    {
      dpes[i] = dpSubStr(dpes[i], DPSUB_SYS_DP_EL);
      dyn_dyn_mixed dpeData;
      if (dynContains(dpesWithData, dpes[i]))
        dpeData = dpeToData[dpes[i]];
      
      _fwSysOverviewLongTermReport_prepareData(endDate, days, dpes[i], dpeData);      
      //store back to the mapping 
      dpeToData[dpes[i]] = dpeData;
      dynAppend(newData, dpeData);
      
    }
    
  }
  else
  {
    for(int i =1; i<=dynlen(dpes);i++)
    {
      dyn_dyn_mixed dpeData;
      _fwSysOverviewLongTermReport_prepareData(endDate, days, dpes[i], dpeData);
      //store back to the mapping 
      dpeToData[dpes[i]] = dpeData;
      dynAppend(newData, dpeData);
    }
  }
  if(store)
    fwSysOverviewLongTermReport_storeChartsUrls(dpeToData, endDate, days);
  data = newData;
}

mapping _fwSysOverviewLongTermReport_makeMapping(dyn_dyn_mixed portionedData)
{
  mapping dpeToData;
  for (int i=1; i<=dynlen(portionedData); i++)
  {
    dyn_dyn_mixed dpeData  = portionedData[i];
    // 1 because it for sure have at least one line and 3 because thedpe is in the third column
    dpeToData[dpeData[1][3]] = dpeData;
  }
  return dpeToData;
}


string _fwSysOverviewLongTermReport_getFileSystemDp(string fmcNode, string mountPoint)
{
  dyn_string fileSystemDps = dpNames(fmcNode + "/Monitoring/FS/fs_*", "FwFMCFs");
  string fsMountPoint;
  for(int i=1; i<=dynlen(fileSystemDps); i++)
  {
    dpGet(fileSystemDps[i] + ".readings.mount_point", fsMountPoint);
    if (fsMountPoint == mountPoint)
      return fileSystemDps[i];
  }
  return ""; 
}
dyn_string fwSysOverviewLongTermReport_createApplicationFSRootCharts(string application, time endDate, int days, bool plotOnTheSameChart = true)
{
  return _fwSysOverviewLongTermReport_createApplicationFSCharts(application, endDate, days, "/", "FS /", plotOnTheSameChart);
}

dyn_string fwSysOverviewLongTermReport_createApplicationFSOptCharts(string application, time endDate, int days, bool plotOnTheSameChart = true)
{
  return _fwSysOverviewLongTermReport_createApplicationFSCharts(application, endDate, days, "/opt", "FS /opt", plotOnTheSameChart);
}

dyn_string _fwSysOverviewLongTermReport_createApplicationFSCharts(string application, time endDate, int days, string mountPoint,  string chartTitle, bool plotOnTheSameChart = true)
{
  dyn_string chartUrls;
  dyn_string fileSystemDps;
  dyn_dyn_mixed data;
  dyn_dyn_string dps = fwSysOverviewFsm_getChildrenOfTypeWithDomain(application, "FwFMCNode", application);   
  for(int i = 1; i <= dynlen(dps); i++)
  {
    string fileSystemDp = _fwSysOverviewLongTermReport_getFileSystemDp(dps[i][1], mountPoint);
    if(fileSystemDp == "")
      continue;
    dynAppend(fileSystemDps, fileSystemDp + ".readings.user");
  }
  int rc = fwSysOverviewLongTermReport_getAverageDataOverTime(endDate, days, fileSystemDps, data);
  if (rc==0)
  {  
    _fwSysOverviewLongTermReport_prepareDataMultipleDp(endDate, days, fileSystemDps, data);
    chartUrls = _fwSysOverviewLongTermReport_createChartUrl(fileSystemDps, data, endDate, days, chartTitle, "%", plotOnTheSameChart);
  }
  
  return chartUrls;
}

dyn_string fwSysOverviewLongTermReport_createApplicationUsedSwapCharts(string application, time endDate, int days, bool plotOnTheSameChart = true)
{
  return _fwSysOverviewLongTermReport_createApplicationFMCNodeMemCharts(application, endDate, days,  "/Monitoring/Memory.readings.usedSwap", "Used Swap", plotOnTheSameChart);
}
dyn_string fwSysOverviewLongTermReport_createApplicationUsedMemoryCharts(string application, time endDate, int days, bool plotOnTheSameChart = true)
{
  return _fwSysOverviewLongTermReport_createApplicationFMCNodeMemCharts(application, endDate, days,  "/Monitoring/Memory.readings.userMemory", "Used Memory", plotOnTheSameChart);
}

//date should be dd/mm/yyyy
time _fwSysOverviewLongTermReport_convertStringToTime(string date)
{
  dyn_string dateStr = strsplit(date, "/");
  if (dynlen(dateStr) != "3")
    return 0;
  return makeTime(dateStr[3], dateStr[2], dateStr[1]);
}

int _fwSysOverviewLongTermReport_getDaysBetween(time startOriginal, time endOriginal)
{
  //eliminate the differences caused by the presence of time
  time start = makeTime(year(startOriginal), month(startOriginal), day(startOriginal));
  time end = makeTime(year(endOriginal), month(endOriginal), day(endOriginal));  
  int timePeriod = (int)end - (time) start;
  if (timePeriod < 0)
   timePeriod = -timePeriod;
  int numberOfDays = timePeriod/(60*60*24);
  return numberOfDays; 
}

dyn_string _fwSysOverviewLongTermReport_getLabels(time endDate, int numberOfDays)
{
  dyn_string labels;
  string format = "%d/%m";
  string end = formatTime(format, endDate);
  time startDate = (int)endDate - (numberOfDays-1)*24*60*60;

  //we always want 7 labels, including the first and the last date
  int ratio = numberOfDays/6;
  dynAppend(labels, formatTime(format, startDate));
  int cycleLimit = (int) endDate + 24*60*60;
  for(int i = (int)startDate + ratio*24*60*60; i < cycleLimit; i+=ratio*24*60*60)
  {
    dynAppend(labels, formatTime(format,(time) i));
  }
  dynAppend(labels, formatTime(format, endDate));
  return labels;
}

void _fwSysOverviewLongTermReport_formatChartDataString(time end, int days, dyn_dyn_mixed data, string& chartDataStr, string& chartLegend)
{
  time start = (int)end - (days-1)*24*60*60;
  //data is first ordered by dpName and then by date -> when dp changes new series for the chart  
  float xAxisDataRange = 100./(days-1);
  //round to 1 digit after decimal
  string tmpStr;
  sprintf(tmpStr, "%3.1f", xAxisDataRange);
  //set it back to the float
  xAxisDataRange = (float) tmpStr;
  float currentXAxisData = 0;
  string lastDp;
  string xAxisStr, avgDataStr;
  dyn_string legend;
  for (int i=1; i <= dynlen(data); i++)
  {
    if (lastDp != "" &&  lastDp != data[i][3])
    {
      //first remove the last , from both strings
      xAxisStr = substr(xAxisStr,0, strlen(xAxisStr)-1);
      avgDataStr = substr(avgDataStr,0, strlen(avgDataStr)-1);
      //save
      chartDataStr += xAxisStr + "|" + avgDataStr + "|";
      //clear for the next dpe
      xAxisStr = "";
      avgDataStr = "";
    }
    if (lastDp == "" | lastDp != data[i][3])
    {
      if(!dpExists(data[i][3]))
      {
        DebugN("*******Error: _fwSysOverviewLongTermReport_formatChartDataString -> dp does not exist: " + data[i][3]);
        DebugN("getStackTrace", getStackTrace(), end, days, data);
        continue;
      }
      string dpType = dpTypeName(data[i][3]);
    
      if (patternMatch("*FMC*", dpType))
      {
        dynAppend(legend, fwFMC_getNodeName( data[i][3])); 
      }
      else
      {
        dynAppend(legend, data[i][3]);
      }
    }
    xAxisStr +=  xAxisDataRange*_fwSysOverviewLongTermReport_getDaysBetween(start, _fwSysOverviewLongTermReport_convertStringToTime(data[i][1])) + ",";
    avgDataStr += data[i][2] + ",";
    lastDp = data[i][3];
  }
  //add the last values
  if (xAxisStr != "" && avgDataStr !="")
  {
    xAxisStr = substr(xAxisStr,0, strlen(xAxisStr)-1);
    avgDataStr = substr(avgDataStr,0, strlen(avgDataStr)-1);
    chartDataStr += xAxisStr + "|" + avgDataStr + "|";
  }
  //remove the last |
  if(strlen(chartDataStr)>0)
    chartDataStr = substr(chartDataStr, 0, strlen(chartDataStr)-1);

  fwGeneral_dynStringToString(legend, chartLegend);
}

int fwSysOverviewLongTermReport_getAverageDataOverTime(time endDate, int numberOfDays, dyn_string dps, dyn_dyn_mixed& data, bool isPercents=true)
{
  string end = formatTime("%d/%m/%Y", endDate);
  time startDate = (int)endDate - (numberOfDays-1)*24*60*60;
  string start = formatTime("%d/%m/%Y", startDate);
  string dpsStr;
  //ensure that the system name is included
  for(int i=1; i<=dynlen(dps); i++)
  {
    dps[i] = dpSubStr(dps[i], DPSUB_SYS_DP_EL);
    if (i%NUMBER_OF_ELEMETS_IN != 0 || (i%NUMBER_OF_ELEMETS_IN == 0 && i == dynlen(dps)))
      dpsStr += "'" + dps[i] + "'" + ",";
    else
    {
      dpsStr += "'" + dps[i] + "') or b.ELEMENT_NAME in(";
    }
    
  }
  //string dpsStr = (string) dps;
  //strreplace(dpsStr, " | ", "','");
  dpsStr = substr(dpsStr, 0 , strlen(dpsStr)-1);
  int rc;
  if (strlen(dpsStr) > 0)
  {
    string query;
    if (isPercents)
    {
      query = "SELECT TO_CHAR(trunc(TS), 'dd/mm/yyyy'), TO_CHAR(avg(value_number), '999.9'), b.ELEMENT_NAME  "+
                   "FROM eventhistory a inner join elements b "+
                   "ON a.ELEMENT_ID=B.ELEMENT_ID "+
                   "WHERE a.TS >="+
                   "TO_DATE(:1, 'dd/mm/yyyy') "+
                   "AND ( b.ELEMENT_NAME in(" + dpsStr+") " + 
                   " ) AND value_number <= 100 AND value_number >= 0 " + 
                   "GROUP BY trunc(TS), b.ELEMENT_NAME " +
                   "ORDER BY b.ELEMENT_NAME, trunc(TS) ASC";
    }
    else
    {
       query = "SELECT TO_CHAR(trunc(TS), 'dd/mm/yyyy'), TO_CHAR(avg(value_number), '999999999'), b.ELEMENT_NAME  "+
                   "FROM eventhistory a inner join elements b "+
                   "ON a.ELEMENT_ID=B.ELEMENT_ID "+
                   "WHERE a.TS >="+
                   "TO_DATE(:1, 'dd/mm/yyyy') "+
                   "AND ( b.ELEMENT_NAME in(" + dpsStr+") " + 
                   " ) AND value_number >= 0 " + 
                   "GROUP BY trunc(TS), b.ELEMENT_NAME " +
                   "ORDER BY b.ELEMENT_NAME, trunc(TS) ASC";
    }
 
    dyn_mixed var;
    var[1] = start;
    rc = _fwSysOverviewLongTermReport_executeQuery(query, var, data);
    //DebugN(data);
    
  }
  else 
    rc = 1;
  return rc;
}

int _fwSysOverviewLongTermReport_executeQuery(string query, dyn_mixed record, dyn_dyn_mixed& data)
{
 

  dbCommand cmd;
  string errTxt;
  
  string server, username, password, owner;
  int plotsPerChart, reportPeriod;
  string filePath;
  int rc = -1;
  if(dpExists("fwSystemOverviewReportsConfig"))
  {
   dpGet("fwSystemOverviewReportsConfig.dbConnection.server", server,
         "fwSystemOverviewReportsConfig.dbConnection.username", username,
         "fwSystemOverviewReportsConfig.dbConnection.password", password,
         "fwSystemOverviewReportsConfig.dbConnection.schemaOwner", owner);
          
    rc = fwSysOverviewLongTermReport_openRdbConnection(server, username, password, owner); 
    if (!rc)
    {
      rdbStartCommand(connectionName,query, cmd);
      if (rdbCheckError(errTxt,cmd)){fwInstallation_throw("DB ERROR" +errTxt+" "+query);return -1;};

      rdbBindParams(cmd, record);
      if (rdbCheckError(errTxt,cmd)){fwInstallation_throw("DB Error: "+errTxt + +query);return -1;};

      rdbExecuteCommand(cmd);
 
      if (rdbCheckError(errTxt,cmd)){fwInstallation_throw("DB ERROR" +errTxt+" "+query);return -1;};

      rc=rdbGetData(cmd, data);
      if (rdbCheckError(errTxt,cmd)){fwInstallation_throw("DB ERROR" +errTxt+" "+query);return -1;};
    
      rc = rdbFinishCommand(cmd);
      // note that we do not put the second parameter here!
      if (rdbCheckError(errTxt)){fwInstallation_throw("DB Error: "+ errTxt + " " + query);return -1;};
  
    }
  }
  return rc;
}


int fwSysOverviewLongTermReport_openRdbConnection(string database, 
                                                   string username, 
                                                   string password, 
                                                   string owner, 
                                                   string driver = "QOCI8")
{
  dbConnection dbCon;
  string errTxt;
  
  string connectionString = "driver="+driver+";database="+database+";uid="+username+";enc_pwd=" + password;

  int rc=rdbGetConnection(connectionName, dbCon);
  rdbCheckError(errTxt,dbCon);
  
  if(rc != 0) 
  {
    DebugN("Opening connection.");
    rc = rdbOpenConnection(connectionString, dbCon, connectionName);
    if(rdbCheckError(errTxt,dbCon))
    {
      DebugN("err: " + errTxt);
    }  
  }

  return rc;
}

int fwSysOverviewLongTermReport_disconnect()
{
 int rc = rdbCloseConnection(connectionName);
 DebugN("Closing connection. Result: " + rc);
}

string _fwSysOverviewLongTermReport_calculateScaling(dyn_dyn_mixed data, int numberOfPlots = 1)
{
  string scalingStrData;
  string scalingStrAxis;
  string scalingStr;
  float minVal=100, maxVal=0;
  for (int i=1; i<= dynlen(data) ; i++)
  {
    float currentVal = data[i][2];
    if (currentVal > maxVal)
      maxVal = currentVal;
    
    if (currentVal < minVal)
      minVal = currentVal;
  
  }
 
  if (minVal == maxVal)
  {
    if (minVal > 1)
      minVal -= 1;
    else minVal = 0;
    maxVal +=1;
  }
  if (minVal != 100 || maxVal != 0)
  {
    // get the first "round" number before min and the first "round" number after max
    int minY = (minVal/10) * 10;
    int maxY = (maxVal/10) * 10 + 1;
    //it should repeat for each of the data series
    for(int i=1;i<=numberOfPlots; i++)
      scalingStrData += "0,100," + (string) minY + "," + (string) maxY + ",";
    if (strlen(scalingStrData) > 0)
      scalingStrData = substr(scalingStrData,0,strlen(scalingStrData)-1);
    float yStep = ((maxY - minY)*1.)/10;
    scalingStrAxis = "1," + (string) minY + "," + (string) maxY + "," + (string) yStep;
  }
  
  if (scalingStrData != "" && scalingStrAxis != "")
    scalingStr = "&amp;chds=" + scalingStrData + "&amp;chxr=" + scalingStrAxis;
  return scalingStr;
}


dyn_string _fwSysOverviewLongTermReport_createChartUrl(dyn_string dpes, dyn_dyn_mixed data, time endDate, int numberOfDays, string chartCaption, string units, bool plotOnTheSameChart = true, string legend = "")
{
  dyn_string colors = makeDynString("0A00F0", "FFC832", "64C864", "FF64B4", "00C8FF", "009696", "FF000A", "8282FF");
  string colorsStr = (string) colors;
  strreplace(colorsStr, " | ", ",");
 
  dyn_string labels = _fwSysOverviewLongTermReport_getLabels(endDate, numberOfDays);
  string labelsStr;
  fwGeneral_dynStringToString(labels, labelsStr, "|"); 
  dyn_string chartUrls;
  int plotsPerChart = _fwSysOverviewLongTermReport_getPlotsPerChart();
  
  if (plotOnTheSameChart)
  {
    string chartDataStr;
    string chartLegend;
    _fwSysOverviewLongTermReport_formatChartDataString(endDate, numberOfDays, data, chartDataStr, chartLegend);
    //if we haven't passed other legend, we should use the fmcNodes
    if(legend != "")
      chartLegend = legend;
    strreplace(chartLegend, "#","");
    
    string scalingStr = _fwSysOverviewLongTermReport_calculateScaling(data, dynlen(dpes));  
    string chartUrl = "https://chart.googleapis.com/chart?"+
                      "cht=lxy&amp;"+//chart type
                      "chs=350x250&amp;"+//chart size
                      "chco="+ colorsStr + "&amp;"//color
                      "chxt=x,y&amp;"+//axis
                      "chd=t:" + chartDataStr + "&amp;" +
                      "chdl="+chartLegend + "&amp;chdlp=t&amp;chtt=" + chartCaption  + scalingStr;
  
    chartUrl += "&amp;chxl=0:|" + labelsStr ;
    //add the units
    if(units!="")
      chartUrl += "&amp;chxs=1N**" + units;
    strreplace(chartUrl, " ", "");
    dynAppend(chartUrls, chartUrl);
  }
  else
  {
     dyn_dyn_mixed portionedData = _fwSysOverviewLongTermReport_portionData(data, plotsPerChart);
     for (int i=1; i<=dynlen(portionedData); i++)
     {
       string chartDataStr;
       string chartLegend;
       _fwSysOverviewLongTermReport_formatChartDataString(endDate, numberOfDays, portionedData[i], chartDataStr, chartLegend);
       string scalingStr = _fwSysOverviewLongTermReport_calculateScaling(portionedData[i], plotsPerChart);
       string currentChartUrl = "https://chart.googleapis.com/chart?"+
                      "cht=lxy&amp;"+//chart type
                      "chs=350x250&amp;"+//chart size
                      "chco="+ colorsStr + "&amp;"//color
                      "chxt=x,y&amp;"+//axis
                      "chd=t:" + chartDataStr + "&amp;" +
                      "chdl="+chartLegend + "&amp;chdlp=t&amp;chtt=" + chartCaption + scalingStr;
  
       currentChartUrl += "&amp;chxl=0:|" + labelsStr ;
       //add the units
       currentChartUrl += "&amp;chxs=1N**%";
       strreplace(currentChartUrl, " ", "");
       dynAppend(chartUrls, currentChartUrl);
       
    }
     
    
  }
  
 
  return chartUrls;
}
dyn_dyn_mixed _fwSysOverviewLongTermReport_portionData(dyn_dyn_mixed originalData, int portionSize)
{
  dyn_dyn_mixed portionedData;
  int portionedDataIndex = 0;
  string previousDp;
  int portionCurrentSize;
  bool firstAdding = false;
  for (int i=1; i<=dynlen(originalData); i++)
  {
    if (previousDp == originalData[i][3] || portionCurrentSize < portionSize)
    {
      //just att it to the last portion
      dyn_dyn_mixed currentContent;
      if (portionedDataIndex > 0)
      {
        currentContent = portionedData[portionedDataIndex];
        currentContent[dynlen(currentContent) + 1] = originalData[i];
        portionedData[portionedDataIndex] = currentContent;
      }
      else
      {
        portionedDataIndex = 1;
        dyn_dyn_mixed tmp;
        tmp[1] = originalData[i];
        portionedData[portionedDataIndex] = tmp;
      }
      
     
      if (previousDp != originalData[i][3])
         portionCurrentSize++; 
    }
    else //start new portion
    {
      portionedDataIndex++;
      dyn_dyn_mixed tmp;
      tmp[1] = originalData[i];
      portionedData[portionedDataIndex] = tmp;
      portionCurrentSize = 1;
        
    }
    previousDp = originalData[i][3];
  
  }
  return portionedData;
}

dyn_string fwSysOverviewLongTermReport_createChart(dyn_string dps, time endDate, int days, string chartTitle, string units="", string legend = "", bool isPercents=true)
{
  dyn_string chartUrls ;
  dyn_dyn_mixed data;
  int rc = fwSysOverviewLongTermReport_getAverageDataOverTime(endDate, days, dps, data, isPercents);
  
  if (rc==0)
  { 
    _fwSysOverviewLongTermReport_prepareDataMultipleDp(endDate, days, dps, data, false);
    chartUrls = _fwSysOverviewLongTermReport_createChartUrl(dps, data, endDate, days, chartTitle, units, true, legend);
  }
  
  return  chartUrls ;
}

dyn_string  fwSysOverviewLongTermReport_createApplicationMonitoredProcessesCharts(string application, time endDate, int reportPeriod)
{
  dyn_string chartUrls;
  dyn_string nodes,ex;
  dyn_dyn_string dps = fwSysOverviewFsm_getChildrenOfTypeWithDomain(application, "FwFMCNode", application);   
  for(int i = 1; i <= dynlen(dps); i++)
  {
    dynAppend(nodes, fwFMC_getNodeName(dps[i][1]) );
  }
  for(int i=1; i<=dynlen(nodes); i++)
  {
    dyn_string processes = fwFMCProcess_getMonitoredProcesses(nodes[i], ex);
    dyn_string optionsDpes, nameDpes;
    dyn_string cpuDps, memoryDps;
    
    for(int j=1; j<=dynlen(processes); j++)
    {
      dynAppend(optionsDpes, processes[j] + ".config.cmd");
      dynAppend(nameDpes, processes[j] + ".config.name");                
      dynAppend(cpuDps, processes[j] + ".readings.cpu");
      dynAppend(memoryDps, processes[j] + ".readings.memory");

    }
   
    if(dynlen(processes) > 0)
    {
      dyn_string options, names;
      dpGet(optionsDpes, options, nameDpes, names);
      dyn_string legend;
      //create the legend
      for(int j=1; j<=dynlen(processes); j++)
      {
       dynAppend(legend, names[j]);  
      }
      
      string legendStr = legend;
      strreplace(legendStr, " | ", "|");
      dyn_string cpuChartUrls = fwSysOverviewLongTermReport_createChart(cpuDps, endDate, reportPeriod, "Monitored Processes CPU" ,"%", legendStr);
      dynAppend(chartUrls,cpuChartUrls);                
      dyn_string memoryChartUrls = fwSysOverviewLongTermReport_createChart(memoryDps, endDate, reportPeriod, "Monitored Processes Memory" ,"KB", legendStr, false);
      dynAppend(chartUrls,memoryChartUrls);        
    }
  }  
  return chartUrls   ;
}    
void  fwSysOverviewLongTermReport_createApplicationFecCharts(string application, time endDate, int reportPeriod)
{
  dyn_string chartUrls;
  dyn_dyn_string aliases = fwSysOverviewFsm_getChildrenOfTypeWithDomain(application, "IcemonFec", application);   
  string cpuTrend, freeMemTrend, inactMemTrend, usedSwapTrend;
  for(int i=1; i<=dynlen(aliases); i++)
  {
    dyn_string freeMemoryDps;
    string dp = dpSubStr(dpAliasToName(aliases[i][1]), DPSUB_DP);
     
    chartUrls = fwSysOverviewLongTermReport_createChart( dp+  ".ProcessInput.readings.cpu.value", endDate, reportPeriod, " Used CPU" ,"%", "UsedCpu");
    if (dynlen(chartUrls) > 0) cpuTrend = chartUrls[1];

    chartUrls = fwSysOverviewLongTermReport_createChart( dp+  ".ProcessInput.readings.freeMemory.value", endDate, reportPeriod, " Free Memory" ,"%", "FreeMemory");  
    if (dynlen(chartUrls) > 0) freeMemTrend = chartUrls[1];
    
    chartUrls = fwSysOverviewLongTermReport_createChart( dp+  ".ProcessInput.readings.inactMemory.value", endDate, reportPeriod, " Inactive Memory" ,"%", "InactMemory");    
    if (dynlen(chartUrls) > 0) inactMemTrend = chartUrls[1];
    
    // = fwSysOverviewLongTermReport_createChart( dp+  ".ProcessInput.readings.usedSwap.value", endDate, reportPeriod, " Used swap" ,"%", "UsedSwap");
    //if (dynlen(chartUrls) > 0) usedSwapTrend = chartUrls[1];
    
    
    dpSet(dp + ".TrendUrls.usedCpu", cpuTrend ,
          dp + ".TrendUrls.freeMemory", freeMemTrend,
          dp + ".TrendUrls.inactMemory", inactMemTrend);
          //dp + ".TrendUrls.usedSwap", usedSwapTrend );
  }  
  
}  


int fwSysOverviewLongTermReport_generateOverviews()
{
  fwInstallationDB_connect();
  string path = gWebPath + "projectsOverview/";
  
  // Projects overview
  dyn_dyn_mixed projectsInfo;
  fwInstallationDB_getProjectsOverview(projectsInfo);
  fwSystemOverview_saveProjectsInfo2Xml(path + "projectsOverview.xml", projectsInfo);
  
  // Hosts overview
  dyn_dyn_mixed hostsInfo;
  fwInstallationDB_getHostsOverview(hostsInfo);
  fwSystemOverview_saveHostsInfo2Xml(path + "hostsOverview.xml", hostsInfo);
  
  // File Issues overview
  dyn_dyn_mixed filesInfo;
  fwInstallationDB_getFilesOverview(filesInfo);
  fwSystemOverview_saveFilesInfo2Xml(path + "fileIssuesOverview.xml", filesInfo);
  
  return 0;  
}
